#PomPi 2016 Copyright 2016-2018, Dezmo
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#---------------------------------------------------------------------------- 

module Dezmo_pompi2016

####################################################################################

#	Creating bend (or curved pipe or elbow or call it as you want...)
	def self.pompi_bend(p2,vector,curent_angle,trans)
	
	@abe=curent_angle if curent_angle #if the caller give current angle we use it 
	
	mod = Sketchup.active_model # Open model
	ent = mod.entities # All entities in model
	sel = mod.selection # Current selection
	definitions = mod.definitions # all component definitions
	
	mod.start_operation("PompI: Create bend.",true) if @kind!="pipe_auto"

# New 2018	
layer_act = mod.active_layer
pompi_layer_pipe=mod.layers.add("PomPi_@")
pompi_layer_cent=mod.layers.add("PomPi_cl")	
pompi_layer_centp=mod.layers.add("PomPi_cp")	
# New 2018	

	exsist = false
	definitions.each {|e| 
		if (e.name==((@cnam2 + (((100.0*@abe.radians.round(2)).to_i)/100.0).to_s) +" "+ @cdes2))
		exsist = true
			#puts "We have it already!" #debug
		@pipeb = e
				
		end #if
	}
	
	if exsist==false
		vb = Geom::Vector3d.new 0,0,1 # vector for base circle
		c_ba = Geom::Point3d.new 0,0,0 #center of base circle
		c =[] # the array of path vertices
		
		@pipeb = mod.definitions.add "Bend "
		entities = @pipeb.entities
		@pipeb.name = ((@cnam2 + (((100.0*@abe.radians.round(2)).to_i)/100.0).to_s) +" "+ @cdes2)
		@pipeb.description =   "PomPi " + Time.now.to_s
	@pipeb.behavior.is2d         = true
	@pipeb.behavior.cuts_opening = true
		# puts  @pipeb.name , @pipeb.description  # debug

	# Get the vertices of curve of bend. If we are using 'arc', the start and end edge is not perpendicular to radius...
	# so the "extruded" bend looks ugly... Here we will modify the 'arc' start and end edges
	# I like this more than other method... :-)
	# The bend will be created in the origin of model (0,0,0), 
	# then later on will be transformed to desired place.
		0.upto(@sbe) do |i| # according to bend segments we are doing something on each vertex
		# Normally the vertices coordinates calculated by simple sin/cos rule  
			c[i] = Geom::Point3d.new 0,@rbe-@rbe*Math.cos((i*@abe/@sbe)),@rbe*Math.sin((i*@abe/@sbe))
		
			# the second point y-cord will be same as first point y-cord, 
			# so the first edge will be perpendicular to base circle (parallel to z axis)
			if i == 1 
				c[i] = Geom::Point3d.new 0,@rbe-@rbe*Math.cos(((i-1)*@abe/@sbe)),@rbe*Math.sin((i*@abe/@sbe))
			end #if
			
			# The vertex before last must be moved too:
			if i == (@sbe-1)
			   c[i+1] = Geom::Point3d.new 0,@rbe-@rbe*Math.cos(((i+1)*@abe/@sbe)),@rbe*Math.sin(((i+1)*@abe/@sbe)) # we need the last point
				# get a vector what is perpendicular to last radius edge:
			   v2 = Geom::Vector3d.new 0,Math.sin(((i+1)*@abe/@sbe)),Math.cos(((i+1)*@abe/@sbe))
				# this vector is perpendicular to v2
			   v1 = Geom::Vector3d.new 0,-Math.cos(((i+1)*@abe/@sbe)),Math.sin(((i+1)*@abe/@sbe))
				# if only two segments this vector is perpendicular to first radius edge
			   v1 = Geom::Vector3d.new 0,Math.sin(((i-1)*@abe/@sbe)),Math.cos(((i-1)*@abe/@sbe)) if @sbe == 2
				# line from before last vertex
			   line1 = [c[i],v1]
				# line from first vertex if only two segments
			   line1 = [c[i-1],v1] if @sbe == 2
				# line from end vertex
			   line2 = [c[i+1],v2]
				# intersect the two line will give the right vertex
			   c[i] = Geom.intersect_line_line(line1, line2)
			end #if
		end #upto

		# Create a path according smoothness 
# New 2018
mod.active_layer = pompi_layer_cent
# New 2018
		if @smo == "1"
			path = @pipeb.entities.add_curve(c)
			else 
			path = @pipeb.entities.add_edges(c)
		end #if

		
# New 2018
mod.active_layer = pompi_layer_pipe
# New 2018		
		# Create a base circles according circle/polygon
		if @ngo == "1"
			b_base_o = @pipeb.entities.add_circle(c_ba, vb, @ro1, @spi)
			b_base_i = @pipeb.entities.add_circle(c_ba, vb, @ri1, @spi) if @ri1 != 0
			else 
			b_base_o = @pipeb.entities.add_ngon(c_ba, vb, @ro1, @spi)
			b_base_i = @pipeb.entities.add_ngon(c_ba, vb, @ri1, @spi) if @ri1 != 0
		end #if
		
		# Create face whit hole or not
		face_base_i = @pipeb.entities.add_face(b_base_i) if @ri1 != 0 # first the inner, if we have
		face_base_o = @pipeb.entities.add_face(b_base_o) # than the outer face 
		face_base_i.erase!  if @ri1 != 0 # now we can remove the hole
		#face_base_o = face_base_o.reverse!
		
		# Rotate the cross-section:
		trpi = Geom::Transformation.rotation c_ba, vb, @rpi # transform
		entities.transform_entities(trpi, face_base_o) 		
		
		# Extrude base face by follow me method  
		face_base_o.followme(path)

# New 2018
mod.active_layer = pompi_layer_centp
# New 2018		
		# some guide points
cp=[];magic0=[];magic1=[]		
		inspoint1 = @pipeb.entities.add_cpoint([0,@rbe,0])
cp[0]=Geom::Point3d.new 0,@rbe,0
		if @abe.radians > 181 or @abe.radians < 179 # if angle is too close to 180 degrees do not put this guide point
			tan = Math.sin((@abe/2))/Math.cos((@abe/2))
			inspoint2 = @pipeb.entities.add_cpoint([0,0,(@rbe*tan)])
cp[1]=Geom::Point3d.new 0,0,(@rbe*tan)
		end #if
magic0=c.to_a
magic1=cp
@pipeb.set_attribute "PomPi", "Magic_points0", magic0
@pipeb.set_attribute "PomPi", "Magic_points1", magic1


	end #if exsist==false
	
# New 2018
mod.active_layer = layer_act
# New 2018

	
	if curent_angle
		tr = Geom::Transformation.new(p2, vector) if @kind!="pipe_auto"
		#tr = @tr_temp_g*trans if @kind=="pipe_auto" #@tr_temp_g is "extra" transform becouse of temporaly group in Dezmo_pompi2016_auto.rb
		tr = trans if @kind=="pipe_auto" 
		
		this = Sketchup.active_model.active_entities.add_instance(@pipeb,tr)
		Sketchup.active_model.select_tool Dezmo_pompi2016::Pompi_Rotate.new this, @kind if @kind=="pipe_bend" #not used since 2018

	else
		Sketchup.active_model.select_tool Dezmo_pompi2016::Place_pompi_component.new @pipeb, @kind, @rbe, @abe
		#mod.commit_operation if @kind!="pipe_auto"
	end	#if
	

	end # self.pompi_bend

end #module Dezmo_pompi2016
