//PomPi 2016 Copyright 2016-2018, Dezmo

// Global variables
var lines = [];


// Stop animation of PomPi (change picture)
// called from: onpompiload(); id = "anipompi"
function anipompijs() {
		document.getElementById("anipompi").src = 'anipompi1.gif';
}

// Functions to call when html interface starts
// called from: _ ; <body onload
function onpompiload() {
	disablemm_inch();
	calcsegangle();
	toinch();
	styleselect();
	setTimeout(anipompijs, 12000);
}

// Reload / reset to defaults the page
// called from: _ ; button id="myreload"
function myreload() {
    location.reload();
}

// called from: _ ; id='pipestandard', id='currentfilename'
function get_csvdata_from_ruby() {
	window.location = 'skp:load_csv_to_html@';
}


// SketchUP call: js_command3
function set_unit(unit) {
		var currentfilename = unit.toString();
		var unitfromfilename = currentfilename.slice(0,2);
		document.getElementById("currentfilename").value = currentfilename;
		if (unitfromfilename == "in") {
			document.getElementById("dimtypei").checked = true;	
		} else if (unitfromfilename == "mm") {
			document.getElementById("dimtypem").checked = true;	
		} else {
		alert("Sorry, can't get what is the dimension format. First two letter of file name must be 'mm' or 'in'! Please check yourself now...");
		}
}

// CSV file process ##############################################################################
// I don't really remember from where I get it (googled)... anyway thanks for it! (I added some bits...)
// called from: _ ; id="csvFileInput"
// obsolete but I leave it here (ruby will handle)
function handleFiles(files) {
	// Check for the various File API support.
	if (window.FileReader) {
		var currentfilename = (files[0]).name;
		// Check for dimension unit (from file name)
		var unitfromfilename = currentfilename.slice(0,2);
		document.getElementById("currentfilename").value = currentfilename;
			if (unitfromfilename == "in") {
				document.getElementById("dimtypei").checked = true;	
				
			} else if (unitfromfilename == "mm") {
				document.getElementById("dimtypem").checked = true;	

			} else {
			alert("Sorry, can't get what is the dimension format. First two letter of file name must be 'mm' or 'in'! Please check yourself now...");
			}
			
		// FileReader are supported, let's go!		
		getAsText(files[0]);
	} else {
		// FileReader are not supported.	
		alert('FileReader are not supported in this browser.');
	}
}

function getAsText(fileToRead) {
	var reader = new FileReader();
	// Handle errors load
	reader.onload = loadHandler;
	reader.onerror = errorHandler;
	// Read file into memory as UTF-8      
	reader.readAsText(fileToRead);
}

function loadHandler(event) {
	var csv = event.target.result;
	processData(csv);             
}

function processData(csv) {
    var allTextLines = csv.split(/\r\n|\n/);
	lines = [];
	clearprev();
    while (allTextLines.length) {
        lines.push(allTextLines.shift().split(','));
    }
	//console.log(lines);
	drawOutput(lines);
	return lines;
}
// above obsolete but I leave it here (ruby will handle)

//SketchUP call: js_command1,js_command2 (finally it is same as above ;-) 
function processdatasu(csvdata) {
    var allTextLines = csvdata.split(/\r\n|\n/);
	lines = [];
	clearprev();
    while (allTextLines.length) {
        lines.push(allTextLines.shift().split(','));
    }
	//console.log(lines); //debug
	drawOutput(lines);
	return lines;
}

function errorHandler(evt) {
	if(evt.target.error.name == "NotReadableError") {
		alert("Canno't read file !");
	}
}

function drawOutput(lines){
	//Clear previous data
	document.getElementById("output").innerHTML = "";
	// Create table just for debug and learn...
	var table = document.createElement("table");
	
	var x = document.getElementById("dimselect");
	var x2 = document.getElementById("dimselect2");
	var option = [];
	var option2 = [];
	for (var i = 0; i < lines.length; i++) {
		var row = table.insertRow(-1);
		for (var j = 0; j < lines[i].length; j++) {
			var firstNameCell = row.insertCell(-1);
			firstNameCell.appendChild(document.createTextNode(lines[i][j]));
		}
		// Create/add options for dimension selection (both start/end pipe)
		if (i > 0){
			option = document.createElement("option");
			option.text = lines[i][0];
			x.add(option);
			option2 = document.createElement("option");
			option2.text = lines[i][0];
			x2.add(option2);
		}
	}
	document.getElementById("output").appendChild(table); // Table is there but hidden in html :-)...
	document.getElementById("pipestandard").innerHTML = lines[0][0]; // firs row first col (to top of the table)
	x.selectedIndex = 0 ;// select default arbitrarily
	x2.selectedIndex = 0 ;// select default arbitrarily
	changedata();
	changedata2();

}
// CSV file process ##############################################################################

//Clear previous options of select fields
// called from: processData(csv) ;
function clearprev(){
		var x = document.getElementById("dimselect");
		var cont = x.length;
		var x2 = document.getElementById("dimselect2");
		var cont2 = x2.length;
		for (var i = 0; i < cont; i++) {
			if (x.length > 0 ){
				x.selectedIndex = 0;
				x.remove(x.selectedIndex);
			}
		}
		for (var j = 0; j < cont2; j++) {
			if (x2.length > 0 ){
				x2.selectedIndex = 0;
				x2.remove(x2.selectedIndex);
			}
		}
}

// Check and change decimal point: comma to dot, if not number than 0/90 (in degree fields)
// called from: bendpic() ; id='abe' , id='rpi'
function todot( who ){
	var a = who.value.replace(",",".") ;
	who.value = Number(a);
	switch(who.id) {
	    case "rpi":
		if (who.value == "NaN") { 
			who.value = 0; 
		}
		styleselect();
		break;
		
	    case "factor":
		if (who.value == "NaN") { 
			who.value = 1.3; 
		}
		calcreducer();
		styleselect();
		break;		
		
	    case "abe":
		if (who.value == "NaN") {
			who.value = 90 ; 
		}
		if (((who.value)%180==0) && (parseFloat(document.getElementById("sbe").value)==2 )) {
			document.getElementById("sbe").value= 3 ; 
			document.getElementById("sbe").style.border="2px solid orange";
			setTimeout(function nb(){(document.getElementById("sbe").style.border="");}, 5000);
		}
		break;
	}
}	

// Check and change to number > 2or3, if not number than 12 (in segment fields)
// called from: _; id='sbe' , id='spi'
function tonum( who ){
	var a = who.value.replace(",",".") ;
	who.value = Number(a).toFixed(0);
	if (who.value == "NaN") { 
		who.value = 12 ;
	}
	switch(who.id) {
	    case "sbe":
			if (who.value <= 2) {
				who.value = 2;  
				if ((parseFloat(document.getElementById("abe").value))%180==0) {
					who.value = 3;
				}
			}
			if (who.value > 96) {
				who.value = 96;  
			}
		break;
		
	    case "spi":
			if (who.value < 3) {
				who.value = 3;  
			}
			if (who.value > 96) {
				who.value = 96 ;
			}
		break;
	}
	calcsegangle();
	styleselect();
}	

// Calculate angle of one segment
// called from: tonum(); id='segmentangle'
function calcsegangle() {
	document.getElementById("segmentangle").innerHTML = "AS:"+Math.round(10*360/parseFloat(document.getElementById("spi").value))/10;
}


// Check and change decimal point: comma to dot, if not number than 0 (in mm fields)
// Some basic input data comparation & correction ...
// called from: _ ; 13 times input fields id='xxxi'
function tommc( who ){
	var a = who.value.replace(",",".") ;
	who.value = Number(a);
	if (who.value == "NaN") { 
		who.value = 0 ; 
	}
	if (who.value < 0.004 && who.value != 0) { 
		who.value = 0.004 ; 
	}
	tomm();
}	

// Convert inch to mm	
// called from: tommc( who ),changedata(), changedata2() ;
function tomm(){
		document.getElementById("do1m").value =  Math.round(10*(parseFloat(document.getElementById('do1i').value))*25.4)/10;
		document.getElementById("di1m").value =  Math.round(10*(parseFloat(document.getElementById('di1i').value))*25.4)/10;
		document.getElementById("ltsm").value =  Math.round(10*(parseFloat(document.getElementById('ltsi').value))*25.4)/10;
		document.getElementById("rbem").value =  Math.round(10*(parseFloat(document.getElementById('rbei').value))*25.4)/10;
		document.getElementById("dunm").value =  Math.round(10*(parseFloat(document.getElementById('duni').value))*25.4)/10;
		document.getElementById("tunm").value =  Math.round(10*(parseFloat(document.getElementById('tuni').value))*25.4)/10;
		document.getElementById("lunm").value =  Math.round(10*(parseFloat(document.getElementById('luni').value))*25.4)/10;
		document.getElementById("dflm").value =  Math.round(10*(parseFloat(document.getElementById('dfli').value))*25.4)/10;
		document.getElementById("cflm").value =  Math.round(10*(parseFloat(document.getElementById('cfli').value))*25.4)/10;
		document.getElementById("tflm").value =  Math.round(10*(parseFloat(document.getElementById('tfli').value))*25.4)/10;
		document.getElementById("lrem").value =  Math.round(10*(parseFloat(document.getElementById('lrei').value))*25.4)/10;
		document.getElementById("do2m").value =  Math.round(10*(parseFloat(document.getElementById('do2i').value))*25.4)/10;
		document.getElementById("di2m").value =  Math.round(10*(parseFloat(document.getElementById('di2i').value))*25.4)/10;
		// Calculate reducer length if selected
		var lre = document.getElementById("lre").checked;
		if 	(lre == true) {
			calcreducer();
		}
}

// Check and change decimal point: comma to dot, if not number than 0 (in inch fields)
// called from: _ ; 13 times imput fileds id='xxxm'
function toinchc( who ){
	var a = who.value.replace(",",".") ;
	who.value = Number(a);
	if (who.value == "NaN") { 
		who.value = 0 ; 
	}
	if (who.value < 0.1 && who.value != 0) { 
		who.value = 0.1 ; 
	}
	toinch();
}

// Convert mm to inch
// called from: toinchc( who ),changedata(), changedata2() ;
function toinch(){
		document.getElementById("do1i").value =  Math.round(10000*(parseFloat(document.getElementById('do1m').value))/25.4)/10000;
		document.getElementById("di1i").value =  Math.round(10000*(parseFloat(document.getElementById('di1m').value))/25.4)/10000;
		document.getElementById("ltsi").value =  Math.round(10000*(parseFloat(document.getElementById('ltsm').value))/25.4)/10000;
		document.getElementById("rbei").value =  Math.round(10000*(parseFloat(document.getElementById('rbem').value))/25.4)/10000;
		document.getElementById("duni").value =  Math.round(10000*(parseFloat(document.getElementById('dunm').value))/25.4)/10000;
		document.getElementById("tuni").value =  Math.round(10000*(parseFloat(document.getElementById('tunm').value))/25.4)/10000;
		document.getElementById("luni").value =  Math.round(10000*(parseFloat(document.getElementById('lunm').value))/25.4)/10000;
		document.getElementById("dfli").value =  Math.round(10000*(parseFloat(document.getElementById('dflm').value))/25.4)/10000;
		document.getElementById("cfli").value =  Math.round(10000*(parseFloat(document.getElementById('cflm').value))/25.4)/10000;
		document.getElementById("tfli").value =  Math.round(10000*(parseFloat(document.getElementById('tflm').value))/25.4)/10000;
		document.getElementById("lrei").value =  Math.round(10000*(parseFloat(document.getElementById('lrem').value))/25.4)/10000;
		document.getElementById("do2i").value =  Math.round(10000*(parseFloat(document.getElementById('do2m').value))/25.4)/10000;
		document.getElementById("di2i").value =  Math.round(10000*(parseFloat(document.getElementById('di2m').value))/25.4)/10000;
		// Calculate reducer length if selected
		var lre = document.getElementById("lre").checked;
		if 	(lre == true) {
			calcreducer();
		}	
}

// Change data according to selected line for main pipe dimension (start pipe)
// called from: drawOutput(lines), ;id='dimselect'
function changedata(){
    var line = lines;
	var y = document.getElementById("dimselect");
	var ind = y.selectedIndex + 1;
	var dimmm = document.getElementById("dimtypem").checked;
	if (dimmm == true) {
		if (ind > 0) {
			document.getElementById("do1m").value = line[ind][1];
			document.getElementById("di1m").value = line[ind][2];
			document.getElementById("ltsm").value = line[ind][3];
			document.getElementById("rbem").value = line[ind][4];
			document.getElementById("dunm").value = line[ind][5];
			document.getElementById("tunm").value = line[ind][6];
			document.getElementById("lunm").value = line[ind][7];
			document.getElementById("dflm").value = line[ind][8];
			document.getElementById("cflm").value = line[ind][9];
			document.getElementById("tflm").value = line[ind][10];
		}
	toinch();	
	}	
	if (dimmm == false) {
		if (ind > 0) {
			document.getElementById("do1i").value = line[ind][1];
			document.getElementById("di1i").value = line[ind][2];
			document.getElementById("ltsi").value = line[ind][3];
			document.getElementById("rbei").value = line[ind][4];
			document.getElementById("duni").value = line[ind][5];
			document.getElementById("tuni").value = line[ind][6];
			document.getElementById("luni").value = line[ind][7];
			document.getElementById("dfli").value = line[ind][8];
			document.getElementById("cfli").value = line[ind][9];
			document.getElementById("tfli").value = line[ind][10];
		}
	tomm();
	}
	disablemm_inch();
}

// Change data according to selected line for 2nd pipe dimension (end pipe)
// called from: drawOutput(lines), ; id='dimselect2'
function changedata2(){
    var line = lines;
	var y = document.getElementById("dimselect2");
	var ind = y.selectedIndex + 1;
	var dimmm = document.getElementById("dimtypem").checked;
	if (dimmm == true) {
		if (ind > 0) {
			document.getElementById("do2m").value = line[ind][1];
			document.getElementById("di2m").value = line[ind][2];
		}
	toinch();
	}
	if (dimmm == false) {
		if (ind > 0) {
			document.getElementById("do2i").value = line[ind][1];
			document.getElementById("di2i").value = line[ind][2];
		}
	tomm();
	}
	disablemm_inch();
}

// Calculate reducer length
// called from: tomm(), toinch() ; id='lre'
function calcreducer() {
	var lre = document.getElementById("lre").checked;
	var fac = parseFloat(document.getElementById("factor").value);
	var dimmm = document.getElementById("dimtypem").checked;
	
	if 	(lre == true) {
			var dom1 = parseFloat(document.getElementById('do1m').value);
			var dom2 = parseFloat(document.getElementById('do2m').value);	
			document.getElementById("lrem").value = Math.round(10*fac*Math.abs(dom1-dom2))/10;
			var doi1 = parseFloat(document.getElementById('do1i').value);
			var doi2 = parseFloat(document.getElementById('do2i').value);	
			document.getElementById("lrei").value = Math.round(10000*fac*Math.abs(doi1-doi2))/10000;
			document.getElementById("factor").disabled = false;
			if (dimmm == true) {
			document.getElementById("lrem").disabled = true;
			}
			if (dimmm == false) {
			document.getElementById("lrei").disabled = true;
			}
			
		} else {
			document.getElementById("factor").disabled = true;
			if (dimmm == true) {
			document.getElementById("lrem").disabled = false;
			}
			if (dimmm == false) {
			document.getElementById("lrei").disabled = false;
			}
		}
}

// Change bend picture according to bend smooth and pipe is circle/polygon
// called from: pipepic(),   ; id='smoth'
function bendpic() {
		var y = Number(document.getElementById("smoth").checked);
		var x = Number(document.getElementById("circ").checked);
		document.getElementById("bcs").src = "bc"+x+"s"+y+".gif";
		todot(document.getElementById("abe"));
		styleselect();
}

// Change pipe picture according to pipe is circle/polygon
// called from: _; id='ngon', id='circ'
function pipepic() {
	if (document.getElementById("circ").checked == true) {
		document.getElementById("pcr").src = "pc1.gif";	
		} else {
		document.getElementById("pcr").src = "pn1.gif";
	}
	bendpic();
}

// Disable warn window
// called from:id='warn_dim'
function nowarn(){
	document.getElementById("warn_dim").style.display = "none";	
}

// Disable mm or inch input field according selected
// called from: onpompiload(), changedata(),changedata2() ; id='dimtypem' , id='dimtypei'
function disablemm_inch(){
	var dimmm = document.getElementById("dimtypem").checked;
	var unitfromfilename = (document.getElementById("currentfilename")).value.slice(0,2);
	
	if (dimmm == false) {
	
		if (unitfromfilename == "mm") {
			document.getElementById("warn_dim").style.display = "";	
		} else {
			document.getElementById("warn_dim").style.display = "none";		
		}
		document.getElementById("do1m").disabled = true;
		document.getElementById("di1m").disabled = true;
		document.getElementById("ltsm").disabled = true;
		document.getElementById("rbem").disabled = true;
		document.getElementById("dunm").disabled = true;
		document.getElementById("tunm").disabled = true;
		document.getElementById("lunm").disabled = true;
		document.getElementById("dflm").disabled = true;
		document.getElementById("cflm").disabled = true;
		document.getElementById("tflm").disabled = true;
		document.getElementById("lrem").disabled = true;
		document.getElementById("do2m").disabled = true;
		document.getElementById("di2m").disabled = true;

		document.getElementById("do1i").disabled = false;
		document.getElementById("di1i").disabled = false;
		document.getElementById("ltsi").disabled = false;
		document.getElementById("rbei").disabled = false;
		document.getElementById("duni").disabled = false;
		document.getElementById("tuni").disabled = false;
		document.getElementById("luni").disabled = false;
		document.getElementById("dfli").disabled = false;
		document.getElementById("cfli").disabled = false;
		document.getElementById("tfli").disabled = false;
		document.getElementById("lrei").disabled = false;
		document.getElementById("do2i").disabled = false;
		document.getElementById("di2i").disabled = false;			
	}
	
	if (dimmm == true) {
		if (unitfromfilename == "in") {
			document.getElementById("warn_dim").style.display = "";	
		} else {
			document.getElementById("warn_dim").style.display = "none";		
		}
		document.getElementById("do1m").disabled = false;
		document.getElementById("di1m").disabled = false;
		document.getElementById("ltsm").disabled = false;
		document.getElementById("rbem").disabled = false;
		document.getElementById("dunm").disabled = false;
		document.getElementById("tunm").disabled = false;
		document.getElementById("lunm").disabled = false;
		document.getElementById("dflm").disabled = false;
		document.getElementById("cflm").disabled = false;
		document.getElementById("tflm").disabled = false;
		document.getElementById("lrem").disabled = false;
		document.getElementById("do2m").disabled = false;
		document.getElementById("di2m").disabled = false;

		document.getElementById("do1i").disabled = true;
		document.getElementById("di1i").disabled = true;
		document.getElementById("ltsi").disabled = true;
		document.getElementById("rbei").disabled = true;
		document.getElementById("duni").disabled = true;
		document.getElementById("tuni").disabled = true;
		document.getElementById("luni").disabled = true;
		document.getElementById("dfli").disabled = true;
		document.getElementById("cfli").disabled = true;
		document.getElementById("tfli").disabled = true;
		document.getElementById("lrei").disabled = true;
		document.getElementById("do2i").disabled = true;
		document.getElementById("di2i").disabled = true;	
	}
	calcreducer();
}

function noborder(who){
	who.style.border="";
		document.getElementById("do1m").style.border="";
		document.getElementById("di1m").style.border="";
		document.getElementById("ltsm").style.border="";
		document.getElementById("rbem").style.border="";
		document.getElementById("dunm").style.border="";
		document.getElementById("tunm").style.border="";
		document.getElementById("lunm").style.border="";
		document.getElementById("dflm").style.border="";
		document.getElementById("cflm").style.border="";
		document.getElementById("tflm").style.border="";
		document.getElementById("lrem").style.border="";
		document.getElementById("do2m").style.border="";
		document.getElementById("di2m").style.border="";

		document.getElementById("do1i").style.border="";
		document.getElementById("di1i").style.border="";
		document.getElementById("ltsi").style.border="";
		document.getElementById("rbei").style.border="";
		document.getElementById("duni").style.border="";
		document.getElementById("tuni").style.border="";
		document.getElementById("luni").style.border="";
		document.getElementById("dfli").style.border="";
		document.getElementById("cfli").style.border="";
		document.getElementById("tfli").style.border="";
		document.getElementById("lrei").style.border="";
		document.getElementById("do2i").style.border="";
		document.getElementById("di2i").style.border="";
		
		document.getElementById("abe").style.border="";
}


// Get the component name/description when mouse over on desired component(s), 
// The title will be component name/description, and pass to skp_place_pipe and to sketchup...
// called by: _ ; 14 times onmouseover on toolbar pictures
function mOver (who){
	var dimmm = document.getElementById("dimtypem").checked;
	var stand = document.getElementById("pipestandard").innerHTML;
	if (stand == "Pipe Standard") {
		stand = "-" ; 
	}	
	var standr = stand.replace(/ /g,"_");
	if (dimmm == true) {
		var a = "m" ; 
		var u = " Metric " + standr + " ";
	}
	if (dimmm == false) { 
		var a = "i" ;
		var u = " Imperial " + standr + " ";
	}

	var do1 = document.getElementById("do1"+a).value; // Pipe outside diameter 1
	var di1 = document.getElementById("di1"+a).value; // Pipe inside diameter 1
	var do2 = document.getElementById("do2"+a).value; // Pipe outside diameter 2
	var di2 = document.getElementById("di2"+a).value; // Pipe inside diameter 2

	//var dn1 = document.getElementById("dimselect").value+":"+do1; // "DN"1
	//var dn2 = document.getElementById("dimselect2").value+":"+do2; // "DN"2	
	var dn1 = document.getElementById("dimselect").value; // "DN"1
	var dn2 = document.getElementById("dimselect2").value; // "DN"2
	if (dn1 == "") { dn1 = do1};//rescue
	if (dn2 == "") { dn2 = do2};//rescue
	
	var lts = document.getElementById("lts"+a).value;// T short length
	
	var rbe = document.getElementById("rbe"+a).value; // Bend radius
	var abe = document.getElementById("abe").value; // Bend angle
	var sbe = document.getElementById("sbe").value; // Bend segments
	var smoth = Number(document.getElementById("smoth").checked); // 1 smooth, 0 sharp
	
	var spi = document.getElementById("spi").value; // Pipe base segments
	var rpi = document.getElementById("rpi").value; // Pipe base (cross-section) rotation angle
	var ngon = Number(document.getElementById("circ").checked); // 	1 ngon, 0 circ
	
	var lre = document.getElementById("lre"+a).value; // Reducer length
	
	var dun = document.getElementById("dun"+a).value; // Union diameter
	var tun = document.getElementById("tun"+a).value; // Union thickness
	var lun = document.getElementById("lun"+a).value; // Union length
	
	var dfl = document.getElementById("dfl"+a).value; // Flange diameter
	var cfl = document.getElementById("cfl"+a).value; // Flange center diameter
	var tfl = document.getElementById("tfl"+a).value; // Flange thickness
	
	var compname1 = "";// component name 1
	var compdesc1 = "";// component description 1	
	var compname2 = "";// component name 2
	var compdesc2 = "";//component description 2

	var oke = "";

	//Correct the inside diameters
	if (parseFloat(di1)>=parseFloat(do1) || parseFloat(di1)<0) {
		document.getElementById("di1"+a).value=0;
		if (dimmm == true) { toinch()};
		if (dimmm == false) { tomm()};
		document.getElementById("di1"+a).style.border="2px solid orange";
		setTimeout(function nb(){(document.getElementById("di1"+a).style.border="");}, 5000);
	}		
	if (parseFloat(di2)>=parseFloat(do2) || parseFloat(di2)<0) {
		document.getElementById("di2"+a).value=0;
		if (dimmm == true) { toinch()};
		if (dimmm == false) { tomm()};		
		document.getElementById("di2"+a).style.border="2px solid orange";
		setTimeout(function nb(){(document.getElementById("di2"+a).style.border="");}, 5000);
	}
	
	switch(who.value) {
	    case "pipebend":
			// since beta2: added "|| parseFloat(do1)>=2*parseFloat(rbe)"
			if (parseFloat(do1)<=0 || parseFloat(rbe)<=0 || parseFloat(do1)>=1.95*parseFloat(rbe)) {
				oke = "Error! ";
				compname1 = "0: DO1 or RBE :-!! or DO1>=1.95*RBE" ;
				compdesc1 = "";
				
				who.style.border="2px solid red";
				document.getElementById("rbe"+a).style.border="2px solid red";
				document.getElementById("do1"+a).style.border="2px solid red";
				document.getElementById("di1"+a).style.border="2px solid red";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
			} else { 
				oke = "";
				compname1 = "pipe" + u + dn1;
				compdesc1 = do1 + "/" + di1 + (" Pseg" + spi + "/" + ngon + " " + rpi);
				compname2 = "bend"+ u + dn1 + " R" + rbe + " " ; 
				compdesc2 = do1 + "/" + di1 + " Bseg" + sbe + "/" + smoth + (" Pseg" + spi + "/" + ngon + " " + rpi);
				
				who.style.border="2px solid green";
				
				document.getElementById("rbe"+a).style.border="2px solid green";
				document.getElementById("do1"+a).style.border="2px solid green";
				document.getElementById("di1"+a).style.border="2px solid green";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
			}	
	
		break;
		
	    case "pipe":
			if (parseFloat(do1)<=0) {
				oke = "Error! ";
				compname1 = "0: DO1 :-!!" ;
				compdesc1 = "";
				
				who.style.border="2px solid red";
				
				document.getElementById("do1"+a).style.border="2px solid red";
				document.getElementById("di1"+a).style.border="2px solid green";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
			} else {
				oke = "";
				compname1 = "pipe" + u + dn1;
				compdesc1 = do1 + "/" + di1 + (" Pseg" + spi + "/" + ngon + " " + rpi);
				
				who.style.border="2px solid green";

				document.getElementById("do1"+a).style.border="2px solid green";
				document.getElementById("di1"+a).style.border="2px solid green";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
			}	

		break;
				
		case "bend":
		// since beta2: added "|| parseFloat(do1)>=2*parseFloat(rbe)"
			if (parseFloat(do1)<=0 || parseFloat(rbe)<=0 || parseFloat(do1)>=1.95*parseFloat(rbe)) {
				oke = "Error! ";
				compname1 = "0: DO1 or RBE :-!! or DO1>=1.95*RBE" ;
				compdesc1 = "";
				
				who.style.border="2px solid red";
				
				document.getElementById("rbe"+a).style.border="2px solid red";
				document.getElementById("do1"+a).style.border="2px solid red";
				document.getElementById("di1"+a).style.border="2px solid red";
				document.getElementById("abe").style.border="2px solid red";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
				if (document.getElementById("abe").value==0 ||document.getElementById("abe").value>=360) {
					document.getElementById("abe").style.border="2px solid orange";
				}				
			} else {
				oke = "";
				compname1 = "bend"+ u + dn1 + " R" + rbe + " " ;
				compdesc1 = do1 + "/" + di1 + " Bseg" + sbe + "/" + smoth + (" Pseg" + spi + "/" + ngon + " " + rpi);
				
				who.style.border="2px solid green";
				
				document.getElementById("rbe"+a).style.border="2px solid green";
				document.getElementById("do1"+a).style.border="2px solid green";
				document.getElementById("di1"+a).style.border="2px solid green";
				document.getElementById("abe").style.border="2px solid green";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
				if (document.getElementById("abe").value==0 ||document.getElementById("abe").value>=360) {
					document.getElementById("abe").style.border="2px solid orange";
				}
			}		
			
        break;
				
		case "t_eq":
			if (parseFloat(do1)<=0 || parseFloat(do2)<=0 || parseFloat(rbe)<=0) {
				oke = "Error! ";
				compname1 = "0: DO1 or DO2 or RBE :0!!" ;
				compdesc1 = "";
				
				who.style.border="2px solid red";
				
				document.getElementById("rbe"+a).style.border="2px solid red";
				document.getElementById("do1"+a).style.border="2px solid red";
				document.getElementById("di1"+a).style.border="2px solid red";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
				document.getElementById("do2"+a).style.border="2px solid red";
				document.getElementById("di2"+a).style.border="2px solid red";
				if (document.getElementById("di2"+a).value=="0") {
					document.getElementById("di2"+a).style.border="2px solid orange";
				}
			} else {
				oke = "";
				compname1 = "t_equal" + u + dn1 + "/" + dn2 + " "; // Only one t_equal since 2018_2
				compdesc1 = 2*rbe +"/" + rbe + " " + do1 + "/" + di1 + " " +  do2 + "/" + di2 + (" Pseg" + spi + "/" + ngon + " " + rpi);
				
				who.style.border="2px solid green";
				
				document.getElementById("rbe"+a).style.border="2px solid green";
				document.getElementById("do1"+a).style.border="2px solid green";
				if (parseFloat(do1)>=2*parseFloat(rbe)) {
					document.getElementById("rbe"+a).style.border="2px solid orange";
					document.getElementById("do1"+a).style.border="2px solid orange";				
				}
				
				document.getElementById("di1"+a).style.border="2px solid green";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
				document.getElementById("do2"+a).style.border="2px solid green";
				if (parseFloat(do2)>parseFloat(do1)) {
					document.getElementById("do2"+a).style.border="2px solid orange";
				}
				document.getElementById("di2"+a).style.border="2px solid green";
				if (document.getElementById("di2"+a).value=="0") {
					document.getElementById("di2"+a).style.border="2px solid orange";
				}
			}
			
        break;
				
		case "t_short":
			//Check for diameters
			if (parseFloat(do1)<=0 || parseFloat(do2)<=0 || parseFloat(rbe)<=0) {
				oke = "Error! ";
				compname1 = "0: DO1 or DO2 or RBE :0!!" ;
				compdesc1 = "";
				
				who.style.border="2px solid red";
				
				document.getElementById("rbe"+a).style.border="2px solid red";
				document.getElementById("lts"+a).style.border="2px solid red";
				document.getElementById("do1"+a).style.border="2px solid red";
				document.getElementById("di1"+a).style.border="2px solid red";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
				document.getElementById("do2"+a).style.border="2px solid red";
				document.getElementById("di2"+a).style.border="2px solid red";
				if (document.getElementById("di2"+a).value=="0") {
					document.getElementById("di2"+a).style.border="2px solid orange";
				}
			} else {
				oke = "";
				compname1 = "t_short" + u + dn1 + "/" + dn2 + " ";  // Only one t_short since 2018_2
				compdesc1 = 2*rbe +"/" + lts + " " + do1 + "/" + di1 + " " + do2 + "/" + di2 + (" Pseg" + spi + "/" + ngon + " " + rpi);
				
				who.style.border="2px solid green";
				
				document.getElementById("rbe"+a).style.border="2px solid green";
				document.getElementById("lts"+a).style.border="2px solid green";
				document.getElementById("do1"+a).style.border="2px solid green";
				if (parseFloat(do1)>=2*parseFloat(rbe)) {
					document.getElementById("rbe"+a).style.border="2px solid orange";
					document.getElementById("do1"+a).style.border="2px solid orange";				
				}
				
				document.getElementById("di1"+a).style.border="2px solid green";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
				document.getElementById("do2"+a).style.border="2px solid green";
				if (parseFloat(do2)>parseFloat(do1)) {
					document.getElementById("do2"+a).style.border="2px solid orange";
				}
				document.getElementById("di2"+a).style.border="2px solid green";
				if (document.getElementById("di2"+a).value=="0") {
					document.getElementById("di2"+a).style.border="2px solid orange";
				}				
			}

			//Correct the short T "leg" length
			if (parseFloat(lts)<parseFloat(do1)/2) {
				document.getElementById("lts"+a).value = Math.round(10000*1.05*do1/2)/10000;
				document.getElementById("lts"+a).style.border="2px solid orange";
				if (dimmm == true) { toinch()};
				if (dimmm == false) { tomm()};
			}
			
        break;
				
		case "reducer_c":
			//Check for reducer length
			if (parseFloat(lre) <=0 || parseFloat(do1)<=0 || parseFloat(do2)<=0) {
				oke = "Error! ";
				compname1 = "0: DO1 or DO2 or LR is 0!!" ;
				compdesc1 = "";
				
				who.style.border="2px solid red";
				
				document.getElementById("lre"+a).style.border="2px solid red";
				document.getElementById("do1"+a).style.border="2px solid red";
				document.getElementById("di1"+a).style.border="2px solid red";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
				document.getElementById("do2"+a).style.border="2px solid red";
				document.getElementById("di2"+a).style.border="2px solid red";
				if (document.getElementById("di2"+a).value=="0") {
					document.getElementById("di2"+a).style.border="2px solid orange";
				}
			} else {
				oke = "";
				if (parseFloat(do2)<=parseFloat(do1)) {
					compname1 = who.value + u + dn1 + "/" + dn2 + " " + lre+ " ";
					compdesc1 = do1 + "/" + di1 + " " + do2 + "/" + di2 + (" Pseg" + spi + "/" + ngon + " " + rpi);
				} else {
					compname1 = who.value + u + dn2 + "/" + dn1 + " " + lre+ " ";
					compdesc1 = do2 + "/" + di2 + " " + do1 + "/" + di1 + (" Pseg" + spi + "/" + ngon + " " + rpi);
				}
				
				who.style.border="2px solid green";

				document.getElementById("lre"+a).style.border="2px solid green";
				document.getElementById("do1"+a).style.border="2px solid green";
				document.getElementById("di1"+a).style.border="2px solid green";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
				document.getElementById("do2"+a).style.border="2px solid green";
				document.getElementById("di2"+a).style.border="2px solid green";
				if (document.getElementById("di2"+a).value=="0") {
					document.getElementById("di2"+a).style.border="2px solid orange";
				}					
			}
		
        break;
								
		case "reducer_e":
			if (parseFloat(lre) <=0 || parseFloat(do1)<=0 || parseFloat(do2)<=0) {
				oke = "Error! ";
				compname1 = "0: DO1 or DO2 or LR is 0!!"  ;
				compdesc1 = "";
				
				who.style.border="2px solid red";
				
				document.getElementById("lre"+a).style.border="2px solid red";
				document.getElementById("do1"+a).style.border="2px solid red";
				document.getElementById("di1"+a).style.border="2px solid red";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
				document.getElementById("do2"+a).style.border="2px solid red";
				document.getElementById("di2"+a).style.border="2px solid red";
				if (document.getElementById("di2"+a).value=="0") {
					document.getElementById("di2"+a).style.border="2px solid orange";
				}
			} else {
				oke = "";
				if (parseFloat(do2)<=parseFloat(do1)) {
					compname1 = who.value + u + dn1 + "/" + dn2 + " " + lre+ " ";
					compdesc1 = do1 + "/" + di1 + " " + do2 + "/" + di2 + (" Pseg" + spi + "/" + ngon + " " + rpi);
				} else {
					compname1 = who.value + u + dn2 + "/" + dn1 + " " + lre+ " ";
					compdesc1 = do2 + "/" + di2 + " " + do1 + "/" + di1 + (" Pseg" + spi + "/" + ngon + " " + rpi);
				}
				
				who.style.border="2px solid green";

				document.getElementById("lre"+a).style.border="2px solid green";
				document.getElementById("do1"+a).style.border="2px solid green";
				document.getElementById("di1"+a).style.border="2px solid green";
				if (document.getElementById("di1"+a).value=="0") {
					document.getElementById("di1"+a).style.border="2px solid orange";
				}
				document.getElementById("do2"+a).style.border="2px solid green";
				document.getElementById("di2"+a).style.border="2px solid green";
				if (document.getElementById("di2"+a).value=="0") {
					document.getElementById("di2"+a).style.border="2px solid orange";
				}					
			}

        break;
				
		case "union":
			if (parseFloat(do1)<=0 || parseFloat(tun)<=0 || parseFloat(dun)<=0 || parseFloat(dun)<=parseFloat(do1)) {
				oke = "Error! ";
				compname1 = "0: DO1 or TUN or DUN is 0 or DUN<DO1!!" ;
				compdesc1 = "";
				who.style.border="2px solid red";
				
				document.getElementById("dun"+a).style.border="2px solid red";
				document.getElementById("tun"+a).style.border="2px solid red";
				document.getElementById("do1"+a).style.border="2px solid red";
				
			} else {
				oke = "";
				compname1 = who.value + u + dn1;
				compdesc1 = " D" + dun + "/" + tun + " " + do1 + (" Pseg" + spi + "/" + ngon + " " + rpi);
				
				who.style.border="2px solid green";
				document.getElementById("dun"+a).style.border="2px solid green";
				document.getElementById("tun"+a).style.border="2px solid green";
				document.getElementById("do1"+a).style.border="2px solid green";				
			}
			//Correct the union length
			//if (parseFloat(lun)<=parseFloat(tun)) {
			//	document.getElementById("lun"+a).value = Math.round(10000*1.01*tun)/10000;	
			//	document.getElementById("lun"+a).style.border="2px solid orange";
			//	if (dimmm == true) { toinch()};
			//	if (dimmm == false) { tomm()};
			//}

        break;
		
		case "union_fake":
			if (parseFloat(do1)<=0 || parseFloat(tun)<=0 || parseFloat(dun)<=0 || parseFloat(dun)<=parseFloat(do1)) {
				oke = "Error! ";
				compname1 = "0: DO1 or TUN or DUN is 0 or DUN<DO1!!"  ;
				compdesc1 = "";
				who.style.border="2px solid red";
				document.getElementById("dun"+a).style.border="2px solid red";
				document.getElementById("tun"+a).style.border="2px solid red";
				document.getElementById("lun"+a).style.border="2px solid red";
				document.getElementById("do1"+a).style.border="2px solid red";
				
			} else {
				oke = "";
				compname1 = who.value + u + dn1;
				compdesc1 = " D" + dun + "/" + tun + "/" + lun + " " + do1 + (" Pseg" + spi + "/" + ngon + " " + rpi);				
				who.style.border="2px solid green";
				document.getElementById("dun"+a).style.border="2px solid green";
				document.getElementById("tun"+a).style.border="2px solid green";
				document.getElementById("lun"+a).style.border="2px solid green";
				document.getElementById("do1"+a).style.border="2px solid green";				
			}
			//Correct the union length
			if (parseFloat(lun)<=parseFloat(tun)) {
				document.getElementById("lun"+a).value = Math.round(10000*1.01*tun)/10000;
				document.getElementById("lun"+a).style.border="2px solid orange";				
				if (dimmm == true) { toinch()};
				if (dimmm == false) { tomm()};
			}		

        break;
		
		case "flange":
			if (parseFloat(do1)<=0 || parseFloat(tfl)<=0 || parseFloat(dfl)<=0 || parseFloat(dfl)<=parseFloat(do1) ) {
				oke = "Error! ";
				compname1 = "0: DO1 or DFL or TFL is 0 or DFL<DO1!!"  ;
				compdesc1 = "";
				who.style.border="2px solid red";
				document.getElementById("dfl"+a).style.border="2px solid red";
				document.getElementById("cfl"+a).style.border="2px solid red";
				document.getElementById("tfl"+a).style.border="2px solid red";
				document.getElementById("do1"+a).style.border="2px solid red";
			} else {
				oke = "";
				compname1 = who.value + u + dn1;
				compdesc1 = " D" + dfl + "/C" + cfl + "/" + tfl + " " + do1 + (" Pseg" + spi + "/" + ngon + " " + rpi);	
				who.style.border="2px solid green";
				document.getElementById("dfl"+a).style.border="2px solid green";
				document.getElementById("cfl"+a).style.border="2px solid green";
				document.getElementById("tfl"+a).style.border="2px solid green";
				document.getElementById("do1"+a).style.border="2px solid green";
			}

		
			//Correct the falnge flange center dia
			if (parseFloat(cfl) >= parseFloat(dfl) || parseFloat(do1) >= parseFloat(cfl)) {
				document.getElementById("cfl"+a).value = Math.round(10000*(dfl/2+do1/2))/10000;	
				document.getElementById("cfl"+a).style.border="2px solid orange";
				if (dimmm == true) { toinch()};
				if (dimmm == false) { tomm()};
			}	
        break;
		
		case "flange_fake":
			if (parseFloat(tfl)<=0 || parseFloat(dfl)<=0) {
				oke = "Error! ";
				compname1 = "0: DO1 or DFL or TFL is 0!!"  ;
				compdesc1 = "";
				who.style.border="2px solid red";
				document.getElementById("dfl"+a).style.border="2px solid red";
				document.getElementById("tfl"+a).style.border="2px solid red";
			} else {
				oke = "";
				compname1 = who.value + u + dn1;
				compdesc1 = " D" + dfl  + "/" + tfl + (" Pseg" + spi + "/" + ngon + " " + rpi);
				who.style.border="2px solid green";
				document.getElementById("dfl"+a).style.border="2px solid green";
				document.getElementById("tfl"+a).style.border="2px solid green";
			}		
			
		break;
				
		default:
        compname1 = "";
		compdesc1 = "";
        compname2 = "";
		compdesc2 = "";
	}
	who.title = oke + who.id  +  "\n" + compname1 + "\n" + compdesc1 + "\n" + compname2 + "\n" + compdesc2;

}


// call SketchUp and give the data's
// called by: styleselect() ; 14 times onmouseclick on toolbar pictures
function skp_place_pipe( who ) {
	// calculate the radiuses, angle radians, the others just read
	var p2 = 180/Math.PI;
	var ro1 = (parseFloat(document.getElementById('do1i').value)/2).toFixed(4);// Pipe outside radius 1  @ro1
	var ri1 = (parseFloat(document.getElementById('di1i').value)/2).toFixed(4);// Pipe inside radius 1  @ri1
	
	var ro2 = (parseFloat(document.getElementById('do2i').value)/2).toFixed(4); // Pipe outside radius 2  @ro2
	var ri2 = (parseFloat(document.getElementById('di2i').value)/2).toFixed(4); // Pipe inside radius 2  @ri2

	var lts = document.getElementById("ltsi").value; // T short length  @lts
	
	var rbe = document.getElementById("rbei").value; // Bend radius  @rbe
	var abe = document.getElementById("abe").value/p2; // Bend angle  @abe
	var sbe = document.getElementById("sbe").value; // Bend segments  @sbe
	var smoth = Number(document.getElementById("smoth").checked); // 1 smooth, 0 sharp  @smo
	
	var spi = document.getElementById("spi").value; // Pipe base segments  @spi
	var rpi = document.getElementById("rpi").value/p2; // Pipe base (cross-section) rotation angle  @rpi
	var ngon = Number(document.getElementById("circ").checked); // 	1 ngon, 0 circ  @ngo
	
	var lre = document.getElementById("lrei").value; // Reducer length  @lre
	
	var run = (parseFloat(document.getElementById('duni').value)/2).toFixed(4); // Union radius  @run
	var tun = document.getElementById("tuni").value; // Union thickness  @tun
	var lun = document.getElementById("luni").value; // Union length  @lun
	
	var rfl = (parseFloat(document.getElementById('dfli').value)/2).toFixed(4); // Flange radius  @rfl
	var cfl = (parseFloat(document.getElementById('cfli').value)/2).toFixed(4); // Flange center radius  @crf
	var tfl = document.getElementById("tfli").value; // Flange thickness  @tfl
	
	// We have put together above, time to split again :-)
	var str = who.title;
	var ni1 = str.indexOf("\n");
	var ni2 = str.indexOf("\n", ni1+1);
	var ni3 = str.indexOf("\n", ni2+1);
	var ni4 = str.indexOf("\n", ni3+1);

	var compname1 = "";
	var compdesc1 = "";
	var compname2 = "";
	var compdesc2 = "";		
	compname1 = str.slice(ni1+1,ni2);// component name 1 @cn1
	compdesc1 = str.slice(ni2+1,ni3);// component description 1	@cd1
	compname2 = str.slice(ni3+1,ni4);// component name 2  @cn2
	compdesc2 = str.slice(ni4+1);// component description 2  @cd2

//This is data string for SketchUP (dimensions are in inch and radian, native for SketchUP)
	var data = "";// clear data first
		data += ro1 + ',';		//index[0]  pipe start outside radius @ro1
		data += ri1 + ',';		//index[1]  pipe start inside radius) @ri1

		data += ro2 + ',';		//index[2]  pipe end outside radius) @ro2
		data += ri2 + ',';		//index[3]  pipe end inside radius)	@ri2		

		data += lts + ',';		//index[4]  T short length  @lts
		
		data += rbe + ',';		//index[5]  Bend radius  @rbe
		data += abe + ',';		//index[6]  Bend angle  @abe
		data += sbe + ',';		//index[7]  Bend segments  @sbe
		data += smoth + ',';	//index[8]  1 smooth, 0 sharp  @smo
		
		data += spi + ',';		//index[9]  Pipe base segments  @spi
		data += rpi + ',';		//index[10]  Pipe base (cross-section) rotation angle  @rpi
		data += ngon + ',';		//index[11]  1 ngon, 0 circ  @ngo	
		
		data += lre + ',';		//index[12]  Reducer length  @lre
		
		data += run + ',';		//index[13]  Union radius  @run
		data += tun + ',';		//index[14]  Union thickness  @tun
		data += lun + ',';		//index[15]  Union length  @lun	

		data += rfl + ',';		//index[16]  Flange radius  @rfl
		data += cfl + ',';		//index[17]  Flange center radius  @crf
		data += tfl + ',';		//index[18]  Flange thickness  @tfl	

		data += compname1 + ',';//index[19]  Component name 1  @cnam1
		data += compdesc1 + ',';//index[20]  Component description 1  @cdes1
		data += compname2 + ',';//index[21]  Component name 2  @cnam2
		data += compdesc2 + ',';//index[22]  Component description 2  @cdes2			
		
		data += who.id + ',';	//index[23]	what kind of "pipe" (pipe, bend, pipe-bend,.... (id of picture) ) @kind

		data += document.getElementById("pstyleselect").selectedIndex + ','; //index[24] style index
		
		data += document.getElementById("factor").value + ','; //index[25] reducer factor
		
		data += document.getElementById("font_size").selectedIndex + ','; //index[26] fontSize index

		data += Number(document.getElementById("show").checked);	//index[27] Show result of pipe conversion	
//		data += who....
			
	var oke = who.title.slice(0,6);
	if (oke != "Error!") {
	window.location = 'skp:create_pipe@' + data;
	window.self.blur();
//	alert(data)
	}		
}

// Select other css styleSheets 
// called by: write_last_data(last_data), onpompiload(); id:'pstyleselect'
function styleselect() {
	 var x = document.getElementById("pstyleselect").selectedIndex;
		document.getElementById("csslink").href = "pompi"+x+".css";
		
		if (x>=4) {x -= 4;}
		document.getElementById("pipe_auto").src ="autop"+x+".gif";
		document.getElementById("pipe").src ="pip"+x+".gif";
		document.getElementById("pipe_bend").src ="pipbe"+x+".gif";
		document.getElementById("bend").src ="elb"+x+".gif";
		document.getElementById("t_equal1").src ="ttn2"+x+".gif";
		document.getElementById("t_equal2").src ="ttn1"+x+".gif";
		document.getElementById("t_short1").src ="tts2"+x+".gif";
		document.getElementById("t_short2").src ="tts1"+x+".gif";
		document.getElementById("redu_conc").src ="red1"+x+".gif";
		document.getElementById("redu_exc").src ="red2"+x+".gif";
		document.getElementById("union1").src ="uni1"+x+".gif";
		document.getElementById("flange1").src ="fla1"+x+".gif";
		document.getElementById("union2").src ="uni2"+x+".gif";
		document.getElementById("flange2").src ="fla2"+x+".gif";
		skp_place_pipe(document.getElementById("pstyleselect"));
}

//SketchUP call  (js_command2)
function write_last_data(last_data) {
	var p2 = 180/Math.PI;
    var data_arr=last_data.split(',');
	document.getElementById("sbe").value=data_arr[0];
	if (data_arr[1]=="1" ){
		document.getElementById("smoth").checked=true;
		}else{
		document.getElementById("smoth").checked=false;
	}
	document.getElementById("spi").value=data_arr[2];
	document.getElementById("rpi").value=data_arr[3]*p2;
	if (data_arr[4]=="1" ){
		document.getElementById("circ").checked=true;
		}else{
		document.getElementById("circ").checked=false;
	}	
	document.getElementById("pstyleselect").selectedIndex=data_arr[5];
	document.getElementById("factor").value=data_arr[6];
	document.getElementById("font_size").selectedIndex=data_arr[7];
	if (data_arr[8]=="1" ){
		document.getElementById("show").checked=true;
		}else{
		document.getElementById("show").checked=false;
	}	
	
	styleselect();
	fontsizes();
	pipepic();
}

// called by: ; id:'font_size'
function fontsizes() {
	document.body.style.fontSize = document.getElementById("font_size").value;
	skp_place_pipe(document.getElementById("pstyleselect"));
}
