#PomPi 2016 Copyright 2016-2018, Dezmo
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#---------------------------------------------------------------------------- 

module Dezmo_pompi2016

####################################################################################
#	Creating BOM based on ComponentReporter++.rb 
=begin
#-----------------------------------------------------------------------
Copyright 2008 TIG
Permission to use, copy, modify, and distribute this software for 
any purpose and without fee is hereby granted, provided something the 
above copyright notice appear in all copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------
=end

	def self.pompi_bom()
	
	model = Sketchup.active_model # Open model
	entities = model.entities # All entities in model
	ss = model.selection # Current selection
	defi = model.definitions # all component definitions
	ssents=ss.to_a
	mpath=model.path
	if mpath==""
	  UI.messagebox("This 'Untitled' new Model must be Saved\nbefore making PomPi Reports !\nExiting... ")
	  return nil
	end
	mpath=File.dirname(mpath)#(mpath.split("\\")[0..-2]).join("/")###strip off file name
	mname=model.title
	model.start_operation("PomPi Reports")
	Sketchup::set_status_text(("PomPi REPORTER..." ), SB_PROMPT)
	Sketchup::set_status_text(" ", SB_VCB_LABEL)
	Sketchup::set_status_text(" ", SB_VCB_VALUE)

	if ss.length<1 
		UI.messagebox("Please select PomPi Components and try again!\nExiting... ")
		return nil	
	end
	
	pompi_s=ss.find_all{|e| e.is_a?(Sketchup::ComponentInstance) and e.description.include? "PomPi" }
	ss.clear
	ss.add(pompi_s)
	clist=[]	
	if pompi_s.length>0
		pompi_s.each{|c|
		  if c.definition.count_instances > 0 and c.description.include? "PomPi"
		    c_mat=c.material.name if c.material
			c_mat="none" if c.material==nil
			clist.push([c.definition.name,c.layer.name,c_mat,c.description.split("PomPi ")[1]])
		  end#if
		} 
	else
		UI.messagebox("There are NO PomPi Components used in this Selection to make PomPi Reports !\nExiting... ")
		return nil
	end#if
	
	clist.sort!
	clist_count=clist.group_by{|i| i}.map{|k,v| [k, v.count] }
	if not clist[0]
	  UI.messagebox("There are NO PomPi Components used in this Selection/Model to make PomPi Reports !\nExiting... ")
	  return nil
	end#if
	list_raw1=[]
	clist_count.each{|c|
		list_raw1<<((c.to_s).gsub(/['TW'\[\]\"]/,'')).gsub('Bseg','').gsub('Pseg','').gsub(',','')
	}	

	pompi_lines=[]
	list_raw1.each{|line|
		kind=line.split(" ")[0]
		arr=line.split(" ")

		case kind
			when "pipe"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(5,'')
				pipe_line.insert(7,'')
				pipe_line.insert(8,'')
				pipe_line.insert(11,'') if arr.length==14
				pompi_lines<<pipe_line
				if arr.length<14 or arr.length>15
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end
			when "bend"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(7,'')
				pipe_line.insert(11,'')
				pompi_lines<<pipe_line
				if arr.length!=16
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end						
			when "t_equal1"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(5,'')
				pipe_line.insert(8,'')
				pipe_line.insert(11,'')
				pompi_lines<<pipe_line
				if arr.length!=15
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end	
			when "t_equal2"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(5,'')
				pipe_line.insert(8,'')
				pipe_line.insert(11,'')
				pompi_lines<<pipe_line
				if arr.length!=15
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end					
			when "t_short1"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(5,'')
				pipe_line.insert(8,'')
				pipe_line.insert(11,'')
				pompi_lines<<pipe_line
				if arr.length!=15
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end					
			when "t_short2"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(5,'')
				pipe_line.insert(8,'')
				pipe_line.insert(11,'')
				pompi_lines<<pipe_line
				if arr.length!=15
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end					
			when "reducer_c"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(5,'')
				pipe_line.insert(8,'')
				pipe_line.insert(11,'')
				pompi_lines<<pipe_line
				if arr.length!=15
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end					
			when "reducer_e"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(5,'')
				pipe_line.insert(8,'')
				pipe_line.insert(11,'')
				pompi_lines<<pipe_line
				if arr.length!=15
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end					

			when "flange_fake"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(5,'')
				pipe_line.insert(6,'')
				pipe_line.insert(7,'')
				pipe_line.insert(8,'')
				pipe_line.insert(11,'')
				pompi_lines<<pipe_line
				if arr.length!=13
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end					
				
			when "flange"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(5,'')
				pipe_line.insert(7,'')
				pipe_line.insert(8,'')
				pipe_line.insert(11,'')
				pompi_lines<<pipe_line
				if arr.length!=14
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end					
			when "union"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(5,'')
				pipe_line.insert(7,'')
				pipe_line.insert(8,'')
				pipe_line.insert(11,'')
				pompi_lines<<pipe_line
				if arr.length!=14
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end					
			when "union_fake"
				pipe_line=[]
				arr.each{|a| pipe_line<<a}
				pipe_line.insert(5,'')
				pipe_line.insert(7,'')
				pipe_line.insert(8,'')
				pipe_line.insert(11,'')
				pompi_lines<<pipe_line
				if arr.length!=14
					UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
					return nil	
				end					
				
			else
				UI.messagebox("Something is wrong! Didn't you renamed PomPi definition manually?\nExiting... ")
				return nil
		end#case
	}	
### write to csv file...
	ccsv=File.join(mpath, mname+"-PomPi Report.csv")
	
	if File.exist?(ccsv)
		if UI.messagebox("PomPi Report File:\n"+ccsv+"\nalready exist.\nDo you want to overwrite?", MB_YESNO)==IDNO
			return nil
		end
	end
	
	begin
		file=File.new(ccsv,"w")
	rescue### trap if open
		UI.messagebox("PomPi Report File:\n"+ccsv+"\n\nCannot be written - it's probably already open.\nClose it and try making the Report again...\n\nExiting...")
		return nil
	end
	file.puts("Kind,System,Standard,Nom_Diameter,Dim,Bend angle,DO1/DI1,DO2/DI2,Bseg /smooth,Pseg /smooth,Pseg rot_angle,Pipe twist,Layer,Material,Date,Time,GMT+,QTY\n") 
	### title ### add what you want to list here
	pompi_lines.sort!
	pompi_lines.each{|c|
		file.puts c.to_s.gsub(/[' '\[\]\"]/,'')+"\n"
	}
	file.close

	### say it's done...	
	wd_report = UI::WebDialog.new("PomPi Report Tool.", true, "PomPi_Report", 800,800,100,100,true)
	wd_report.set_file (File.dirname( __FILE__ ) + "/pompi_report.html")
	wd_report.close if wd_report.visible?
	if RUBY_PLATFORM.index "darwin"
		wd_report.show_modal
		else
		wd_report.show
	end

	wd_report.add_action_callback("load_csv_to_html") {
		csv_file = File.open ccsv, "r"
		csv_lines = csv_file.readlines.to_s
		csvdata0=(csv_lines.gsub('",','')).gsub('"','')
		csvdata=csvdata0.gsub('[','"').gsub(']','"')
		js_command1="processdatasu("+csvdata+")"
		wd_report.execute_script(js_command1)
		js_command2="document.getElementById('csvfile').innerHTML='"+ccsv.gsub('\\','/')+"';"
		wd_report.execute_script(js_command2)
	}	


	#UI.messagebox("PomPi Report written into:\n\n"+ccsv+"\n\nReported items remain selected.")
	### commit undo...
	model.commit_operation	

	end # self.pompi_bom

end #module Dezmo_pompi2016
