#PomPi 2016 Copyright 2016-2018, Dezmo
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#---------------------------------------------------------------------------- 


	
=begin
to do
ready	soso	notready	future
		# refine 'my protactor' interface
				in some case Auto tool conversions back and force fails...? Nested edges are annoying... 
		UI is a little ugly... 
		The faces disturb the Pompi_Auto_tool, currently erased...
	Error handling ( eg. 'idiotproof') is not taht bad, but... maybe never can be completted...
		User Manual

=end


require 'sketchup.rb'
# "load" only for test period, should be "require"...
load 'Dezmo_pompi2016/Dezmo_pompi2016_line_auto.rb'
load 'Dezmo_pompi2016/Dezmo_pompi2016_line.rb'
load 'Dezmo_pompi2016/Dezmo_pompi2016_rot.rb'
load 'Dezmo_pompi2016/Dezmo_pompi2016_auto.rb'
load 'Dezmo_pompi2016/Dezmo_pompi2016_place.rb'
load 'Dezmo_pompi2016/Dezmo_pompi2016_bend.rb'
load 'Dezmo_pompi2016/Dezmo_pompi2016_t.rb'
load 'Dezmo_pompi2016/Dezmo_pompi2016_uni_fla.rb'
load 'Dezmo_pompi2016/Dezmo_pompi2016_redu.rb'
load 'Dezmo_pompi2016/Dezmo_pompi2016_pipe.rb'
load 'Dezmo_pompi2016/Dezmo_pompi2016_bom.rb'

#----------------------------------------------------------------------------
module Dezmo_pompi2016

### menu & toolbar
unless file_loaded?(__FILE__)
	@cmd1=UI::Command.new("PomPi自由管道 2016"){ self.dezmo_createpompi("_v") }
	@cmd2=UI::Command.new("PomPi自由管道 2016 焊接线"){ self.dezmo_weldedges() }
	@cmd3=UI::Command.new("PomPi自由管道 Z轴旋转" ){self.Pompi_Rotate_tool} 
	@cmd4=UI::Command.new("PomPi自由管道 Z轴扭曲" ){self.Pompi_Twist_tool} 
	@cmd5=UI::Command.new("PomPi自由管道 列表" ){self.pompi_bom()} 

    model = Sketchup.active_model
    sel = model.selection	
	#ent = model.active_entities 
	ent = model.entities
	defi = model.definitions # all component definitions
	
	@cmd2.set_validation_proc {
		valid_edges=sel.find_all {|e| e.kind_of?(Sketchup::Edge) } if sel
    if valid_edges && valid_edges.length>0 
		MF_ENABLED
		else
		MF_GRAYED
		end
	} # end validation	
	
	@cmd3.set_validation_proc {
    if sel.single_object? && (sel[0].is_a?(Sketchup::ComponentInstance) || sel[0].is_a?(Sketchup::Group))
		MF_ENABLED
		else
		MF_GRAYED
		end
	} # end validation

	@cmd4.set_validation_proc {
		if (sel.single_object?) && (sel[0].is_a?(Sketchup::ComponentInstance)) && (sel[0].description.include? "PomPi") && (sel[0].definition.name.include? "pipe")
		MF_ENABLED
		else
		MF_GRAYED
		end
	} # end validation	

	@cmd5.set_validation_proc {
		inst_p=sel.find_all{|e| e.is_a?(Sketchup::ComponentInstance)} if sel
		if (inst_p.find_all{|e| e.description.include? "PomPi"}).length>0 
		MF_ENABLED
		else
		MF_GRAYED
		end
	} # end validation	
	
	pompi_menu=UI.menu("Plugins").add_submenu("PomPi自由管道 © by Dezmo")
	pompi_ver=pompi_menu.add_item(@cmd1)	
	pompi_rot=pompi_menu.add_item(@cmd3)
	pompi_tw=pompi_menu.add_item(@cmd4)
	pompi_bom=pompi_menu.add_item(@cmd5)
	pompi_weld=pompi_menu.add_item(@cmd2)

	@cmd1.small_icon=File.join(File.dirname(__FILE__), "/pompi_menu.png") 
	@cmd1.large_icon=File.join(File.dirname(__FILE__), "/pompi_menu.png") 
	@cmd2.small_icon=File.join(File.dirname(__FILE__), "/pompi_weld.png") 
	@cmd2.large_icon=File.join(File.dirname(__FILE__), "/pompi_weld.png") 
	@cmd3.small_icon=File.join(File.dirname(__FILE__), "/pompi_rot.png") 
	@cmd3.large_icon=File.join(File.dirname(__FILE__), "/pompi_rot.png") 
	@cmd4.small_icon=File.join(File.dirname(__FILE__), "/pompi_twist.png") 
	@cmd4.large_icon=File.join(File.dirname(__FILE__), "/pompi_twist.png") 
	@cmd5.small_icon=File.join(File.dirname(__FILE__), "/pompi_bom.png") 
	@cmd5.large_icon=File.join(File.dirname(__FILE__), "/pompi_bom.png")
	
	@cmd1.tooltip="PomPi自由管道 2016"
	@cmd1.status_bar_text="'自动创建管道!' 将线路转换为管道! 创建无限种类的管道元件 (管道,弯头,三通,...)"
	
	@cmd2.tooltip="PomPi自由管道 2016 焊接线"
	@cmd2.status_bar_text="将多段线焊接为曲线"
	
	@cmd3.tooltip="PomPi自由管道 Z轴旋转"
	@cmd3.status_bar_text="将选择进行Z轴旋转 (仅限一个组件/群组) "
	
	@cmd4.tooltip="PomPi自由管道 Z-axis Twist"
	@cmd4.status_bar_text="将选择进行Z轴扭曲 (仅限一个组件/群组)"

	@cmd5.tooltip="PomPi自由管道 BOM"
	@cmd5.status_bar_text="创建 Pompi自由管道 组件的 CSV 列表，并在 HTML 窗口中显示。"	
	
	toolbar1=UI::Toolbar.new("PomPi自由管道 2016")
	toolbar1.add_item(@cmd1)
	toolbar1.add_separator
	toolbar1.add_item(@cmd3)
	toolbar1.add_separator
	toolbar1.add_item(@cmd4)
	toolbar1.add_separator
	toolbar1.add_item(@cmd5)
	toolbar1.add_separator
	toolbar1.add_item(@cmd2)
	
	toolbar1.restore if toolbar1.get_last_state==TB_VISIBLE
end
file_loaded(__FILE__)
###

####################################################################################
####################################################################################

	def self.dezmo_createpompi(uidirection)
	mod = Sketchup.active_model # Open model
	ent = mod.entities # All entities in model
	sel = mod.selection # Current selection
	definitions = mod.definitions # all component definitions
	uidir=uidirection # vertical or horizontal
	pro_error_text="对不起, 您使用的是免费版本的Sketchup.
不幸的是，这里不支持某些方法.

你不能创建三通，活口和法兰! 
(flange_fake仍然是可能的)

当内径非0时无法创建异径接头! 
将起始端或结束端内径设置为0, 以创建简单异径接头!"
	
	
	#Create a webdialog (horizontal or vertical)	
	dialog_name = 'PomPi 2016 (' + File.dirname( __FILE__ ) + '/ )'
	width=800 if uidir==""
	height=360 if uidir==""
	left=300 if uidir==""
	top=500 if uidir==""
	width=360 if uidir=="_v"
	height=800 if uidir=="_v"
	left=20 if uidir=="_v"
	top=10 if uidir=="_v"
	@pompi_dialog = UI::WebDialog.new( dialog_name, true, 'Dezmo_PomPi_2016_0'+uidir, width, height, left, top, true )
	pathname = File.dirname( __FILE__ ) + "/pompi_20" + uidir + ".html"
	@pompi_dialog.set_file pathname	

	@cmd1.set_validation_proc {
		if @pompi_dialog.visible?
		MF_GRAYED
		else
		MF_ENABLED
		end
	} # end validation	
	#@cmd2.set_validation_proc {
		#if @pompi_dialog.visible?
		#MF_GRAYED
		#else
		#MF_ENABLED
		#end
	#} # end validation	
	#Get data from html
	@pompi_dialog.add_action_callback("create_pipe") {|d, data|
		@v = data.split(",")

		## string.to_f  length to a normal float // .to_l length to current unit
		@ro1 = @v[0].to_f ##index[0]  pipe start outside radius @ro1
		@ri1 = @v[1].to_f ##index[1]  pipe start inside radius) @ri1
		#@ri1 = 0 if @ri1 >= @ro1 ## if inside radius too big it will be solid tube (rod)
		
		@ro2 = @v[2].to_f ##index[2]  pipe end outside radius) @ro2
		@ri2 = @v[3].to_f ##index[3]  pipe end inside radius)  @ri2	
		#@ri2 = 0 if @ri2 >= @ro2 ## if inside radius too big it will be solid tube (rod)
		
		@lts = @v[4].to_f ##index[4]  T short length  @lts
		
		@rbe = @v[5].to_f ##index[5]  Bend radius  @rbe
		@abe = @v[6].to_f ##index[6]  Bend angle  @abe
		@sbe = @v[7].to_f ##index[7]  Bend segments  @sbe
		@smo = @v[8] ##index[8]  1 smooth, 0 sharp  @smo
		
		@spi = @v[9].to_f ##index[9]  Pipe base segments  @spi
		@rpi = @v[10].to_f ##index[10]  Pipe base (cross-section) rotation angle  @rpi
		@ngo = @v[11] ##index[11]  1 ngon, 0 circ  @ngo	
		
		@lre = @v[12].to_f ##index[12]  Reducer length  @lre
		
		@run = @v[13].to_f ##index[13]  Union radius  @run
		@tun = @v[14].to_f ##index[14]  Union thickness  @tun
		@lun = @v[15].to_f ##index[15]  Union length  @lun	#will not use 
		
		@rfl = @v[16].to_f ##index[16]  Flange radius  @rfl
		@cfl = @v[17].to_f ##index[17]  Flange center radius  @crf
		@tfl = @v[18].to_f ##index[18]  Flange thickness  @tfl	
		
		@cnam1 = @v[19] ##index[19]  Component name 1  @cnam1
		@cdes1 = @v[20] ##index[20]  Component description 1  @cdes1
		@cnam2 = @v[21] ##index[21]  Component name 2  @cnam2
		@cdes2 = @v[22] ##index[22]  Component description 2  @cdes2			
		
		@kind = @v[23] ##index[23]	what kind of "pipe" (pipe, bend, pipe-bend, ....) @kind
		
		@style = @v[24] ##index[24]
		
						##index[25] is a reducer factor
						##index[26] is a font size index
		@show_result = @v[27] ##index[24] show the result window after conversion

		@last_data=@v[7]+","+@v[8]+","+@v[9]+","+@v[10]+","+@v[11]+","+@v[24]+","+@v[25]+","+@v[26]+","+@v[27]
			#puts @v #debug

###################################################################################	
#puts @kind #debug		
		if (@kind=="pstyleselect")
			# just a 'dirty' method to store style...and other data... ;-)
		end #if	
###################################################################################	
		if (@kind=="pipe_auto")
			Dezmo_pompi2016::find_edges_vertices(@kind)		
		end #if		
		
#New 2018		
if (@kind=="pipe_bend")
Sketchup.active_model.select_tool Dezmo_pompi2016::Pompi_line_tool_auto.new @kind, @rbe
end #if	
#New 2018

		if ( @kind=="pipe") #or @kind=="pipe_bend" #change 2018
			Sketchup.active_model.select_tool Dezmo_pompi2016::Pompi_line_tool.new @kind, @rbe			
		end #if		
###################################################################################	
		if @kind.include? "union" or @kind.include? "flange"
	
			if (Sketchup.is_pro? == false) && (@kind.include? "union" or @kind.include? "flange1")
			UI.messagebox(pro_error_text)
			Sketchup.send_action "selectSelectionTool:"
			end
		
				# I checked in javascript, so not used here:
				#@run = 2*@ro1 if @run <= @ro1 # the Uni diameter should bigger than pipe
				#@lun = 2*@tun if @lun <= @tun # the Uni l should bigger than t...
				#@rfl = 3*@ro1 if @rfl <= @ro1 # the Fla diameter should bigger than pipe
				#@cfl = (@rfl+@ro1)/2 if (@cfl <= @ro1 or @cfl >= @rfl) # the Fla centercirc should bigger than pipe, smaller than dia
			
			#the bolts half dia is fixed according to pipe diameter... because I so decided ;-) !
			si=0.0393700787401575 # stupid ich ;-)
			@crfl = case (2*@ro1/si) #in case of pipe diameter (in mm)
				when 0..10.0 then ((@rfl-@ro1)/2.5) # just to fit inside
				when 10.0..25.0 then 5.5*si #5.5mm (M10)
				when 25.0..65.0 then 7*si
				when 65.0..250.0 then 9*si
				when 250.0..600.0 then 11*si
				when 600.0..700.0 then 13*si
				when 700.0..1000.0 then 15*si
				else 40*si
			end #case
			@crfl = ((@rfl-@ro1)/2.5) if @crfl>((@rfl-@ro1)/2.5) # I'm trying just to fit inside
			
			# Check if we have the same component already
			exsist = false
			definitions.each {|e| 
				#if ( e.name == @cnam1 + @cdes1 )
				if ( e.name.include? (@cnam1 + @cdes1) )
				exsist = true
					#puts "We have it already!" #debug
				Sketchup.active_model.select_tool Dezmo_pompi2016::Place_pompi_component.new e, @kind, @rbe, @abe				
				end #if
			}		
			self.pompi_uni_fla if exsist == false && (Sketchup.is_pro? or @kind.include? "flange2")
		end #if
###################################################################################	
		if @kind.include? "t_"
		
			if (Sketchup.is_pro? == false)
			UI.messagebox(pro_error_text)
			Sketchup.send_action "selectSelectionTool:"
			end

			#@ro2 = @ro1 if @ro2 > @ro1 # the T head should bigger or equal than leg
			#@ri2 = 0 if @ri2 >= @ro2 # the inside radius should checked again
			#@lts = @ro1*1.05 if @lts <= @ro1 # the T leg should bigger then T head radius
			# Check if we have the same component already
			exsist = false
			definitions.each {|e| 
				#if ( e.name == @cnam1 + @cdes1 )
				if ( e.name.include? (@cnam1 + @cdes1) )
				exsist = true
					#puts "We have it already!" #debug
				Sketchup.active_model.select_tool Dezmo_pompi2016::Place_pompi_component.new e, @kind, @rbe, @abe				
				end #if
			}		
		self.pompi_t_4 if exsist == false && Sketchup.is_pro?
		end #if
###################################################################################	
		if @kind == "redu_conc"	or @kind == "redu_exc"
			# Check if we have the same component already
		
			if (Sketchup.is_pro? == false) && (@ri1>0 or @ri2>0)
			UI.messagebox(pro_error_text)
			Sketchup.send_action "selectSelectionTool:"
			end
		
			exsist = false
			definitions.each {|e| 
				if ( e.name == @cnam1 + @cdes1 )
				exsist = true
					#puts "We have it already!" #debug
				Sketchup.active_model.select_tool Dezmo_pompi2016::Place_pompi_component.new e, @kind, @rbe, @abe			
				end #if
			}		
		self.pompi_reducer if exsist == false && (Sketchup.is_pro? or (@ri1==0 && @ri2==0))
		end #if
###################################################################################	
		if @kind == "bend"
			@cnam2 = @cnam1
			@cdes2 = @cdes1
			self.pompi_bend(nil,nil,nil,nil) #	if exsist == false
		end #if
###################################################################################	
	} #end  @pompi_dialog.add_action_callback ("create_pipe")
	
	# Push the data to webdialog if she is asking (webdialog is feminine!! :-) )
	# (First I wanted to do it in JavaScript only, but there you can't open file... 
	# ..with JavaScript without user interaction... / Ruby don't care about this security. ;-) /)
	@pompi_dialog.add_action_callback("load_csv_to_html") {|d, data| 
		@csv_dirname = File.dirname( __FILE__ )+'/' if (@csv_dirname==nil)
		@csv_filename = UI.openpanel("Open CSV File", @csv_dirname, "csv|*.csv||")

		if @csv_filename
			csv_file = File.open @csv_filename, "r"
			csv_lines = csv_file.readlines.to_s
			csvdata0=(csv_lines.gsub('",','')).gsub('"','')
			csvdata=csvdata0.gsub('[','"').gsub(']','"')
			js_command4="processdatasu("+csvdata+")"	

			unitfromfilename=File::basename(@csv_filename)
			@csv_dirname=File::dirname(@csv_filename)
			js_command3="set_unit('"+unitfromfilename+"')"

			@pompi_dialog.execute_script(js_command3)	
			@pompi_dialog.execute_script(js_command4)
		end #if
	} #end  @pompi_dialog.add_action_callback ("load_csv_to_html")

	#read the stored style of wd, and last loaded csv file
	last_data = Sketchup.read_default "Pompi_2016b0_dialog_data","Last Data","12,1,12,0,1,3,1.3,4,1"
	csv_filename_1=Sketchup.read_default "Pompi_2016b0_dialog_data","csv"
	@csv_filename=csv_filename_1.gsub('_____','\\') if csv_filename_1 #stupid characters
	@csv_filename = File.dirname( __FILE__ ) + "/mm_DIN_DN.csv" if @csv_filename==nil
	begin
		csv_file = File.open @csv_filename, "r"
		rescue
		@csv_filename = File.dirname( __FILE__ ) + "/mm_DIN_DN.csv"
			begin
			csv_file = File.open @csv_filename, "r"
			rescue
			UI.messagebox("PomPi Critical ERROR!\nMissing 'mm_DIN_DN.csv' file!\nPlease Reinstall PomPi!", MB_OK, "PomPi Critical ERROR")
			return nil
				#if RUBY_PLATFORM.index "darwin"
				#	@pompi_dialog.show_modal 
				#	else
				#	@pompi_dialog.show 
				#end	#if
			end
	end	
	csv_lines = csv_file.readlines.to_s
	csvdata0=(csv_lines.gsub('",','')).gsub('"','')
	csvdata=csvdata0.gsub('[','"').gsub(']','"')
	unitfromfilename=File::basename(@csv_filename)

	js_command5="set_unit('"+unitfromfilename+"')"
	js_command1="processdatasu("+csvdata+")"
	js_command2="write_last_data('"+last_data+"')"
		#puts js_command2
	# Display the dialog box 
	if RUBY_PLATFORM.index "darwin"
		@pompi_dialog.show_modal {
			@pompi_dialog.execute_script(js_command1)
			@pompi_dialog.execute_script(js_command2)
			@pompi_dialog.execute_script(js_command5)
		}
		else
		@pompi_dialog.show {
			@pompi_dialog.execute_script(js_command1)
			@pompi_dialog.execute_script(js_command2)
			@pompi_dialog.execute_script(js_command5)
		}
	end	#if	
	
	#store some data, the style of wd, and last loaded csv file when wd close 
	@pompi_dialog.set_on_close{ 
		Sketchup.write_default "Pompi_2016b0_dialog_data", "Last Data", @last_data 
		@csv_filename_norm=@csv_filename.gsub('\\','_____') # need to store other character than '\'
			#puts @csv_filename_norm
		Sketchup.write_default "Pompi_2016b0_dialog_data", "csv", @csv_filename_norm 
	}

	end # self.dezmo_createpompi()

end #module Dezmo_pompi2016
