#PomPi 2016 Copyright 2016-2018, Dezmo
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end
#---------------------------------------------------------------------------- 

module Dezmo_pompi2016

# This part below is based on "Place_Component" & "Component on Face" by sdmitch (SDM Tools) 
#  Thanks!!
#  Get the component definition (pipe_to_place) and what kind (kind) from caller
	class Place_pompi_component

		def initialize(pipe_to_place, kind, rbe, abe)
			@mod=Sketchup.active_model
			@ent=@mod.active_entities
			@sel=@mod.selection
			@ip=Sketchup::InputPoint.new
			@entered=0 #help bit if mouse entered to main window
			@edges_count=0 #conected edges to verex tuched by insertion (cursor)
			@ind_e=0 #index of conected edges to verex tuched by insertion (cursor)

			@cd = pipe_to_place #the "pipe" what was handled over
			@kind = kind # type of pipe (e.g.: bend, t_equal1, redu_conc...)
			# added method to shift T-s bends
			@rbe=rbe
			@abe=abe

			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_b.png"), 0, 0) if @kind.include? "bend"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_te1.png"), 0, 0) if @kind.include? "t_equal1"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_te2.png"), 0, 0) if @kind.include? "t_equal2"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_ts1.png"), 0, 0) if @kind.include? "t_short1"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_ts2.png"), 0, 0) if @kind.include? "t_short2"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_re.png"), 0, 0) if @kind.include? "redu_exc"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_rc.png"), 0, 0) if @kind.include? "redu_conc"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_u.png"), 0, 0) if @kind.include? "union1"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_uf.png"), 0, 0) if @kind.include? "union2"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_f.png"), 0, 0) if @kind.include? "flange1"
			@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_ff.png"), 0, 0) if @kind.include? "flange2"
			
#new 2018_2
			@arr=[];@arr1=[]
			@arr=@cd.get_attribute("PomPi", "Magic_points0")
			@arr1=@cd.get_attribute("PomPi", "Magic_points1")
	
			@shift=0
			@lts=(@arr[2].vector_to @arr[3]).length if @kind.include? "t_short"
			@tr_shift = Geom::Transformation.new([0,0,0])
#new 2018_2		
	
			self.reset
		end
		
		
		def activate
			@status_text = "Pick for Location. // Hit Escape/Right click to abort."
			@status_text +=" // Hit ´shift´ key to shift/unshift insertion point." if (@kind=="t_equal1" or @kind=="t_short1" or @kind == "bend") #New2018
			@status = 0
			Sketchup::set_status_text @status_text,SB_PROMPT
			Sketchup::set_status_text("",SB_VCB_LABEL)
			Sketchup::set_status_text("",SB_VCB_VALUE)	
			if @cd
				@bb = @cd.bounds ; @status = 1
			else
				self.reset #onCancel(nil,nil)
			end			
			
		end			
			
		def onSetCursor
			UI.set_cursor @cursor
		end#def	
		
		def reset
			@status_text = ""
			@status = 0
			@bb = nil
			Sketchup::set_status_text @status_text,SB_PROMPT
			Sketchup::set_status_text("",SB_VCB_LABEL)
			Sketchup::set_status_text("",SB_VCB_VALUE)	
			#onCancel(nil,nil)
		end
		
		def onCancel(flags,view)
			view.invalidate #refresh view
			self.reset
			
			Sketchup.active_model.active_view.refresh
			Sketchup.send_action "selectSelectionTool:"
		end		

			
#######################################################################		
#Trying a "Dirty" method to get focus from html window to SKETCHUP		
		def onMouseEnter(view)
			@entered +=1
#This one seams to works, from https://forums.sketchup.com/t/how-to-set-focus-to-mainwindow/12383/10
			if @entered<2
				dummieDlg = UI::WebDialog.new("dummie", true, "dummie", 0, 0, 10000, 10000, true)
				dummieDlg.show()
				dummieDlg.close()
			end
		end
#Trying a "Dirty" method to get focus from html window to SKETCHUP
#######################################################################		
		
		
		def onMouseMove(flags, x, y, view)
			@ip.pick view,x,y
			view.tooltip = @ip.tooltip
			#view.refresh #?? which one
			view.invalidate #?? which one
			Sketchup::set_status_text @status_text,SB_PROMPT
			Sketchup::set_status_text("",SB_VCB_LABEL)
			Sketchup::set_status_text("",SB_VCB_VALUE)	
			if @ip.face
				Sketchup::set_status_text "Face detected.",SB_PROMPT 
				Sketchup::set_status_text "Face detected. // Hit ´shift´ key to shift/unshift insertion point.",SB_PROMPT if ( @kind.include? "redu_" or @kind.include? "t_" or @kind == "bend") #New2018
				Sketchup::set_status_text("Face",SB_VCB_LABEL)
				Sketchup::set_status_text("",SB_VCB_VALUE)				
			end
			if @ip.edge
				Sketchup::set_status_text "Edge detected.",SB_PROMPT
				Sketchup::set_status_text "Edge detected. // Hit ´shift´ key to shift/unshift insertion point.",SB_PROMPT if ( @kind.include? "redu_" or @kind.include? "t_" or @kind == "bend") #New2018
				Sketchup::set_status_text("Edge",SB_VCB_LABEL)
				Sketchup::set_status_text("",SB_VCB_VALUE)	
			end
			if @ip.vertex
				Sketchup::set_status_text "Multi-edge detected, use arrow keys to choose!",SB_PROMPT
				Sketchup::set_status_text "Multi-edge detected, use arrow keys to choose! // Hit ´shift´ key to shift/unshift insertion point.",SB_PROMPT if ( @kind.include? "redu_" or @kind.include? "t_" or @kind == "bend") #New2018
				Sketchup::set_status_text(@edges_count.to_s+" Edges. Selected:",SB_VCB_LABEL)
				Sketchup::set_status_text((@ind_e+1).to_s,SB_VCB_VALUE)		
			end
		end
		
		def onLButtonDown(flags, x, y, view)
			if @status==1
				this = @ent.add_instance(@cd,@tr)
			##### Bits to hand over the instance to Dezmo_pompi2016_rot.rb 
				Sketchup.active_model.select_tool Dezmo_pompi2016::Pompi_Rotate.new this, @kind, @shift #New2018_2: 3 arg 
			end
		end
		
		def onReturn(view)

		end	
		
		def onRButtonDown(flags, x, y, view)
			@status==1 ? onCancel(flags,view) : self.reset
		end

		def onKeyDown(key, repeat, flags, view)

			if @ip.vertex
				@ind_e=0 if !@ip.vertex.edges
				case key
				 when VK_LEFT then @ind_e +=-1 if @ind_e>0
				 when VK_DOWN then @ind_e +=-1  if @ind_e>0
				 when VK_RIGHT then @ind_e +=1 if @ind_e<@edges_count-1
				 when VK_UP then @ind_e +=1  if @ind_e<@edges_count-1
				 #
				end
			view.invalidate #refresh view	

			Sketchup::set_status_text(@edges_count.to_s+" Edges. Selected:",SB_VCB_LABEL)
			Sketchup::set_status_text((@ind_e+1).to_s,SB_VCB_VALUE)		  
			end#if
			
			if( key == CONSTRAIN_MODIFIER_KEY )
#new 2018_2			
				if (@kind.include?"t_" or @kind.include?"bend" or  @kind.include? "redu_")
					@shift+=1
					@shift=0 if (@shift>2 and @kind.include?"t_") or (@shift>1 and (@kind.include?"redu_" or @kind.include?"bend"))
					view.invalidate
				end
				tan = 1.0
				tan = Math.sin((@abe/2))/Math.cos((@abe/2)) if @kind.include? "bend" and @abe%Math::PI!=0	
				vecdown = Geom::Vector3d.new 0,0,-@rbe*tan if @kind.include? "bend" or (@kind.include? "t_" and @shift==1)
				vecdown = (@arr[1].vector_to @arr[0]) if @kind.include? "redu_conc"	
				vecdown = (@arr[2].vector_to @arr[0]) if @kind.include? "redu_exc"		
				vecdown = Geom::Vector3d.new 0,-@lts,-@rbe if @kind.include? "t_short" and @shift==2
				vecdown = Geom::Vector3d.new 0,-@rbe,-@rbe if @kind.include? "t_equal" and @shift==2
				trdown = Geom::Transformation.translation vecdown if vecdown and vecdown.length>0
				trr = Geom::Transformation.rotation [0,0,0], [1,0,0], -90.degrees if (@kind.include? "t_" and @shift==2)
				trr = Geom::Transformation.rotation [0,0,0], [1,0,0], -180.degrees if @kind.include? "redu_"

				@tr_shift = trr*trdown if ((@kind.include? "t_") and (@shift==2)) or (@kind.include? "redu_")
				@tr_shift = trdown if (@kind.include? "bend" ) or ((@kind.include? "t_") and (@shift==1))				
				view.invalidate
			end
		end	
		
		def draw(view)
			if( @ip.valid? && @ip.display? )
				@ip.draw(view)
			end
		
			@ind_e=0 if @edges_count==0
			@cpt = @ip.position
			@tform = (@ip.transformation)
			if @ip.vertex
				@edges_count = @ip.vertex.edges.length
			#############################################################!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			# we need the original transformation of the point otherwise the vector is normal of original pipe position	
			# the position method on a input point always returns a point that is transformed into model space!!!!!!!!!!!!!			
				@nrm = @ip.vertex.edges[@ind_e].line[1] if @ip.vertex.edges[@ind_e] #vector of [@ind] edge of vertex touched by inputpoint (the index seleted by arrow buttons: onKeyDown above)
				@nrm.transform! @tform
				pt = view.screen_coords(@cpt)
				pt,vec = view.pickray(pt.x,pt.y)
				@nrm.reverse! if @nrm.angle_between(vec)<90.degrees
				xa,ya,za = @nrm.axes
				@tr = (Geom::Transformation.axes(@cpt,xa,ya,za)) if @shift==0
				@tr = (Geom::Transformation.axes(@cpt,xa,ya,za))*@tr_shift if @shift>0

				self.draw_temporary(view)

			elsif @ip.edge
			#############################################################!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			# we need the original transformation of the point otherwise the vector is normal of original pipe position	
			# the position method on a input point always returns a point that is transformed into model space!!!!!!!!!!!!!			
				@nrm = @ip.edge.line[1]
				@nrm.transform! @tform
				pt = view.screen_coords(@cpt)
				pt,vec = view.pickray(pt.x,pt.y)
				@nrm.reverse! if @nrm.angle_between(vec)<90.degrees
				xa,ya,za = @nrm.axes
				@tr = Geom::Transformation.axes(@cpt,xa,ya,za) if @shift==0
				@tr = (Geom::Transformation.axes(@cpt,xa,ya,za))*@tr_shift if @shift>0
				self.draw_temporary(view)
				
			elsif @ip.face
			#############################################################!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			# we need the original transformation of the point otherwise the vector is normal of original pipe position	
			# the position method on a input point always returns a point that is transformed into model space!!!!!!!!!!!!!			
				@nrm = @ip.face.normal
				@nrm.transform! @tform
				pt=view.screen_coords(@cpt)
				pt,vec = view.pickray(pt.x,pt.y)
				@nrm.reverse! if @nrm.angle_between(vec)<90.degrees
				xa,ya,za = @nrm.axes
				@tr = Geom::Transformation.axes(@cpt,xa,ya,za) if @shift==0
				@tr = (Geom::Transformation.axes(@cpt,xa,ya,za))*@tr_shift if @shift>0
				self.draw_temporary(view)
				
			else
				@tr = Geom::Transformation.new(@ip.position) if @shift==0
				@tr = (Geom::Transformation.new(@ip.position))*@tr_shift if @shift>0
				self.draw_temporary(view)

			end #if
			
		end #def draw(view)
		
		def draw_temporary(view)
				if @bb
				view.line_width = 2
				view.drawing_color = 'yellow'
				view.drawing_color = 'Pink' if @ip.face
				view.drawing_color = 'Coral' if @ip.edge
				view.drawing_color = 'green' if@ip.vertex
				
				pts = []
				(0..7).each{|i| pts << @bb.corner(i).transform(@tr)} 
				view.draw GL_LINE_LOOP,pts[0],pts[1],pts[3],pts[2]
				view.draw GL_LINE_LOOP,pts[4],pts[5],pts[7],pts[6]
				(0..3).each{|i| view.draw_line pts[i],pts[i+4]}

				pt0 = @cd.insertion_point.transform(@tr)
				view.draw_points(pt0, 10, 1, "green")	
				view.draw_points(@cpt, 15, 1, "red")					

				@arr_postr=[];@cp_arr=[]
				@arr.each{|a| @arr_postr<<a.transform(@tr)}
				view.draw_points(@arr_postr, 8, 2, "yellow")
				if @arr1[0] and !@kind.include? "redu_"
					@arr1.each{|c| @cp_arr<<c.transform(@tr)} 
					view.draw_points(@cp_arr, 8, 4, "pink") 
				end
				view.line_width = 4
				view.drawing_color = 'blue'
				if @kind=="bend"
						view.draw(GL_LINE_STRIP, @arr_postr)
					else 
						view.draw(GL_LINES, @arr_postr)
				end
				if @kind.include? "redu_"
					a2=[]
					@arr1[1].each{|e| a2<<e.transform(@tr)}
					view.draw(GL_LINE_LOOP, a2)
				end
			end
		end #def draw_temporary		
	end #class
# This part above is based on "Place_Component" by sdmitch (SDM Tools) 
#  Thanks!!	

end #module Dezmo_pompi2016