#PomPi 2016 Copyright 2016-2018, Dezmo

#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end
#---------------------------------------------------------------------------- 

=begin
########This code is based on... my own, mostly... ############################
# 
# 
#
###############################################################################
#The idea come form: Doug Herrman, fillet.rb  ################ Thanks! ########
###############################################################################

###############################################################################
#Some other ideas: weld.rb form Rick Wilson, and TIG-weld from TIG.## Thanks! #
#Copyright 2004-2005 by Rick Wilson, and 2012-2016 (c) TIG. [in parts] ########
###############################################################################

###############################################################################
#Also thanks to Julia Christina Eneroth: Part of 3D Rotate Tool (see below)  ##
###############################################################################

Created and modified by Dezmo (2016). 

The selected lines (edges) converted to pipes an bends. (Somthing like 
Follow Me and/or fillet, but its put individual PomPi's :))
#2018: The selected PomPi´s are also converted back to lines

=end
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#-----------------------------------------------------------------------------
require 'sketchup.rb'
#-----------------------------------------------------------------------------


module Dezmo_pompi2016  #dezmo

	def self.dezmo_weldedges()
		mod = Sketchup.active_model # Open model
		#ent = mod.entities # All entities in model
		ent = mod.active_entities # All active entities in model
		sel = mod.selection # Current selection

		@edges_weld = sel.find_all {|e| e.kind_of?(Sketchup::Edge) } if sel #selected edges
		
		if ( @edges_weld.length < 1 )
			UI.messagebox("Please select 1 or more edges first.", MB_OK, "PomPi Auto Tool")
			Sketchup.send_action "selectSelectionTool:"
			return
		end		
		if ( @edges_weld.length>0 )
			mod.start_operation("PomPi Weld Tool", true)
	# The faces connected to selected edges disturb the transformations, currently they will be deleted...		
			faces_is_not_good=[]
			@edges_weld.each{|e| e.faces.each{|f| faces_is_not_good.push(f) if f.kind_of?(Sketchup::Face)}}
			faces_is_not_good.uniq!
			faces_is_not_good.each{|f| ent.erase_entities f}

	#The curves make SU to crash, explode it (since:2016.06.21 beta2)		
			@edges_weld.each{|e| e.explode_curve if e.explode_curve }
			
	# isolate temporally by group so the not selected edges (which can connected to selected edges) will not disturb 
			#@group_temp = ent.add_group(faces_is_not_good.to_a.concat(@edges.to_a))
			@group_temp_w = ent.add_group(@edges_weld.to_a)
			@tr_temp_g_w=@group_temp_w.transformation # We have to take care about it, during placing the PomPi's!!

			resulte = self.sort_out_vertices_by_edges(@edges_weld,false,@tr_temp_g_w) # get the result from code I'm proud of it :-)

			waves = resulte[0] if resulte
			loops_o = resulte[1] if resulte
			lines = resulte[2] if resulte
			edges_3p=resulte[3] if resulte
			loops = (loops_o.each{|loo| loo<<loo[0]}) if loops_o.length>0

			(waves.each{|wa| ent.add_curve(wa)}) if waves.length>0
			(loops.each{|lo| ent.add_curve(lo)}) if loops_o.length>0
			(lines.each{|li| ent.add_curve(li)}) if lines.length>0
			
			edges_3p.each{|p| Sketchup.active_model.selection.add((Sketchup.active_model.active_entities.add_edges(p)))} if edges_3p.length>0
			count_wrong=Sketchup.active_model.selection.length.to_s
			#erase the temporally groop
			@group_temp_w.erase! if @group_temp_w			
		end
			Sketchup.active_model.active_view.refresh
			Sketchup.active_model.commit_operation
			
	end #self.dezmo_weldedges() 
##################################################################################################

	def self.find_edges_vertices(kind)
		mod = Sketchup.active_model # Open model
		#ent = mod.entities # All entities in model
		ent = mod.active_entities # All active entities in model
		sel = mod.selection # Current selection
		@kind=kind
		@edges=[]
		@edges_1=[]
		@edges_2=[]
		@edges_3=[]		
		@verts_2=[]
		@verts_3=[]
		@time_start=0
		@time_start2=0
		@pompis=[]
		@countb=0 #counter for bends
		@countpb=0 #counter pipes connected to nends
		@cont4=0 #counter for stand alone pipes
		@cout3tw=0 #counter for twisted pipe		

		@edges = sel.find_all {|e| e.kind_of?(Sketchup::Edge) } if sel #selected edges
		
#NEW 2018 Convert PomPi's back to lines 
		@pompis = sel.find_all {
			|p| p.kind_of?(Sketchup::ComponentInstance) and p.description.include? "PomPi" and (p.definition.name.include? "pipe" or p.definition.name.include? "bend")
			} if sel #selected PomPi's
		if ( @edges.length < 1 and @pompis.length < 1 ) #modified
			UI.messagebox("Please select (1 or more edges) OR (1 or more PomPi' pipes/bends) first.", MB_OK, "PomPi Auto Tool")
			Sketchup.send_action "selectSelectionTool:"
			return
		end	
		if ( @edges.length > 0 and @pompis.length > 0 )
			curious = UI.messagebox(
			"You have been selected both edges and PomPi's*.
Convert back and force at once can work,
but may cause unexpected result and/or errors! 
	In worst case SketchUp maybe hangs!
If you'r curious and brave enough Press OK.

Otherwise Press CANCEL, modify your selection and try again!
Please select (1 or more edges) OR (1 or more PomPi's*)!

(*PomPi's: Pipe or Bend created by this PomPi\u00A9 tool.)", MB_OKCANCEL, "PomPi Line<>PomPi tool")

			Sketchup.send_action "selectSelectionTool:" if curious==IDCANCEL
			return if curious==IDCANCEL
		end		
#NEW 2018 Convert PomPi's back to lines 		
		
		# Give an info tu user if it is still run even looks like frozen...
		@wd_working = UI::WebDialog.new("PomPi Auto Tool.", true, "PomPi_Warning", 800,400,100,100,true)
		@wd_working.set_file (File.dirname( __FILE__ ) + "/pompi_warn.html")

		if RUBY_PLATFORM.index "darwin"
			@wd_working.show_modal
			else
			@wd_working.show
		end

		# Get the size from javasript/html
		@wd_working.add_action_callback("resize_wd") {
		    @wd_working.set_size( @wd_working.get_element_value("width").to_f+100,
            [800, @wd_working.get_element_value("height").to_f+105].min )
		}
		
		@wd_working.add_action_callback("close_wd") {
			@wd_working.close 
		}
		
		# I have to use a trick to webdialog show properly. Call webdialog, wait for load, than call back from there to here...
		@wd_working.add_action_callback("go_go") {

#NEW 2018 Convert PomPi's back to lines 
		@satustext_pompi_to_line=""
		layer_act = mod.active_layer
		if ( @pompis.length>0 )
			mod.start_operation("PomPi replace to line", true)
			@time_start2=Time.now
			
			@pompis.each{|p| 
				trpomp=p.transformation
				arr=[]
				mod.active_layer =  p.layer
				p.definition.entities.each{|e| 
				if e.kind_of?(Sketchup::Edge) and e.layer.name == "PomPi_cl"
					if p.definition.name.include? "bend"
						 if (e.start.edges.find_all{|v| v.layer.name == "PomPi_cl"}).length==1
							point1 = e.start.position
							vecp1 = e.start.position.vector_to(e.end.position)
							arr<<point1.transform!(trpomp)
							arr<<vecp1.transform!(trpomp)
						end
						if (e.end.edges.find_all{|v| v.layer.name == "PomPi_cl"}).length==1
							point1 = e.end.position
							vecp1 = e.end.position.vector_to(e.start.position)
							arr<<point1.transform!(trpomp)
							arr<<vecp1.transform!(trpomp)				 
						end
						#@er.push(e)
					else
					ent.add_edges((e.start.position.transform!(trpomp)),(e.end.position.transform!(trpomp)))				
					end#if 
				end#if
				}#e
				if arr.length>3
					pointcorner = Geom.intersect_line_line(([arr[0], arr[1]]), ([arr[2], arr[3]])) 
					dist=(arr[0].distance(arr[2]))/2 # if the bend is 180°
					p180=arr[0].offset(arr[1],dist) # if the bend is 180°
					p181=arr[2].offset(arr[3],dist) # if the bend is 180°
					ent.add_edges(arr[0],p180,p181,arr[2]) if !pointcorner # if the bend is 180°
					ent.add_edges(arr[0],pointcorner,arr[2]) if pointcorner
				end
				p.erase! 
			}#p

			@satustext_pompi_to_line="Total amount of Converted PomPi's to lines: "+@pompis.length.to_s
			Sketchup::set_status_text(@satustext_pompi_to_line,SB_PROMPT)
			Sketchup.active_model.commit_operation		
		end #if
		mod.active_layer=layer_act
		Sketchup.active_model.active_view.refresh
#NEW 2018


		if ( @edges.length>0 )
			mod.start_operation("PomPi Auto Tool", true)
			@time_start=Time.now
			
	# The faces connected to selected edges disturb the transformations, currently they will be deleted...		
			faces_is_not_good=[]
			@edges.each{|e| e.faces.each{|f| faces_is_not_good.push(f) if f.kind_of?(Sketchup::Face)}}
			#@edges.each{|e| e.all_connected.each{|f| faces_is_not_good.push(f) if f.kind_of?(Sketchup::Face)}}
			faces_is_not_good.uniq!
			faces_is_not_good.each{|f| ent.erase_entities f}

	#The curves make SU to crash, explode it (since:2016.06.21 beta2)		
			@edges.each{|e| e.explode_curve if e.explode_curve }
			
	# isolate temporally by group so the not selected edges (which can connected to selected edges) will not disturb 
			#@group_temp = ent.add_group(faces_is_not_good.to_a.concat(@edges.to_a))
			@group_temp = ent.add_group(@edges.to_a)
			@tr_temp_g=@group_temp.transformation # We have to take care about it, during placing the PomPi's!!

			resulte = self.sort_out_vertices_by_edges(@edges,false,@tr_temp_g) # get the result from code I'm proud of it :-)
			waves = resulte[0] if resulte
			loops = resulte[1] if resulte
			lines = resulte[2] if resulte
			edges_3p=resulte[3] if resulte
			#count_wrong=edges_3p.length if edges_3p
			self.pompi_auto_loops(loops) if loops.length>0
			self.pompi_auto_waves(waves) if waves.length>0
			self.pompi_auto_lines(lines) if lines.length>0
			
			# draw back the bad edges

			edges_3p.each{|p| Sketchup.active_model.selection.add((Sketchup.active_model.active_entities.add_line(p)))} if edges_3p.length>0
			count_wrong=Sketchup.active_model.selection.length
			#erase the temporally groop
			@group_temp.erase! if @group_temp			
		end
			Sketchup.active_model.active_view.refresh
			Sketchup.active_model.commit_operation
			Sketchup::set_status_text "PomPi Auto Tool: Job done!",SB_PROMPT	
			elapsed_time1=0
			elapsed_time2=0	
			elapsed_time_text=""
			elapsed_time1= (Time.now-@time_start) if @time_start!=0
			elapsed_time2= (Time.now-@time_start2)if @time_start2!=0
@wd_working.close if @show_result=="0" #[elapsed_time1,elapsed_time2].max<0
			elapsed_time_text= elapsed_time1.to_s if (elapsed_time1>elapsed_time2)
			elapsed_time_text= elapsed_time2.to_s if (elapsed_time1<=elapsed_time2)
			
			
			#The "done" messagebox
			done1="PomPi 自动工具工作已完成!\n\n"
			done2="选定边的总数： "
			done3=@edges.length.to_s
			done4="\n创建的弯管总数： "
			done5=@countb.to_s
			done6="\n连接到弯管的管道总数： "
			done7=@countpb.to_s
			done8="\n创建的独立管道总数： "
			done9=@cont4.to_s

			done11="\n    "+@cout3tw.to_s
			done12=" 个被扭曲" if @cout3tw>1 # Just for proper plural...;-)
			done12="个被扭曲" if @cout3tw<=1
			done13="\n不可转换实体 (已选定): "+count_wrong.to_s
			done14="\n连接的面也被删除！"
			done15="\n已使用: "+elapsed_time_text+" 秒\n"
			done10="\n您可以撤消这一切。 \n"
			
			done=done1+done15+done10+"\n"+"<a style='color:blue'>"+@satustext_pompi_to_line+"</a>"
		if ( @edges.length>0 )
			done=done1+done2+done3+done4+done5+done6+done7+done11+done12+done8+done9+done13+done15+done10+"\n"+"<a style='color:blue'>"+@satustext_pompi_to_line+"</a>"
		end

			donewd=done.gsub("\n","<br>")
			
			# send data to WD
			js_command10='pompi_auto_end("'+donewd+'")'
			@wd_working.execute_script(js_command10)
			#UI.beep
			
			#This is on top of the WD :-) (so above WD redrawn just for fun...)
			#UI.messagebox(done, MB_OK, "PomPi Auto Tool:")
			#@wd_working.close	
			# Bug in SU if you close wd before open UI.messagebox	
			# SU will close UI.messagebox too (before it is really opened)
			
			#timer1= UI::start_timer( 30, false ) { 
			#	@wd_working.close
			#	UI.stop_timer timer1
			#}

		}
	
	end #def self.find_edges_vertices()

	# Intentionally less comments below... ;-) (The idea and some explanation are in my handsketch: bendmeth.png)
	# New in 2018: changed 0 to (-0.00001) for length of lines and bend radius comparation, 
	# otherwise practically zero (e.g. -2.220446049250313e-16) given a false result...Lesson learned!)
	def self.pompi_auto_loops(loops)
	loops.each{|p|	
		p.each_with_index{|point,i|
			
			j=(i-p.length) # small trick to get right point if i+somthing > arraylength ( e.g. i:[0,1,2,..n] is same as j:[-(n+1),..., -3,-2,-1] )
		
			v1=p[i].vector_to p[j+1]  
			v_1=p[i-1].vector_to p[i] 
			v2=p[j+1].vector_to p[j+2]  
			v_2=p[i-2].vector_to p[i-1] 
			v3=p[j+2].vector_to p[j+3]  
			v_3=p[i-3].vector_to p[i-2] 
			
			a=v_1.angle_between v1
			a=Math::PI-a if a<=Math::PI
			a1=v1.angle_between v2
			a1=Math::PI-a1 if a1<=Math::PI
			a_1=v_2.angle_between v_1
			a_1=Math::PI-a_1 if a_1<=Math::PI
			a2=v2.angle_between v3
			a2=Math::PI-a2 if a2<=Math::PI
			a_2=v_3.angle_between v_2
			a_2=Math::PI-a_2 if a_2<=Math::PI
			
			r=@rbe/Math.tan(a/2)
			r1=@rbe/Math.tan(a1/2)			
			r_1=@rbe/Math.tan(a_1/2)
			r2=@rbe/Math.tan(a2/2)
			r_2=@rbe/Math.tan(a_2/2)
			
			dis1 = v1.length
			dis_1 = v_1.length			
			dis2 = v2.length
			dis_2 = v_2.length
			#dis3 = v3.length
			#dis_3 = v_3.length
			
			if (dis1-r-r1>=-0.00001 and dis_1-r-r_1>=-0.00001)# and dis_2-r_1-r_2>=0)# and dis2-r1-r2>=0 ) #if everybody fits in
				#put bend
				insp_bend= p[i].offset v_1.reverse, r
				vec_zn=v_1.normalize
				plane1= p[i],vec_zn
				vec_y=self.flattenVector(plane1, v1)
				vec_yn=vec_y.normalize
				vec_xn=(vec_yn * vec_zn).normalize
				curent_angle = Math::PI-a if a<=Math::PI 
				curent_angle = a  if a>Math::PI 
				trans_for_bend = Geom::Transformation.axes insp_bend, vec_xn, vec_yn, vec_zn
				@countb +=1
				self.pompi_bend(insp_bend,nil,curent_angle,trans_for_bend)			
						
				#put pipe
				insp_pipe=p[i-1].offset v_1, r_1
				lengthpip=insp_pipe.distance insp_bend
				angletw_base=self.angle_between_in_Plane(plane1, v_2, v1)
				angletw_base=angletw_base-Math::PI/@spi if @spi%2>0
				angletw=angletw_base%(2*Math::PI/@spi)
				angletw=-(2*Math::PI/@spi)+angletw if angletw>(Math::PI/@spi)
				trans_for_pipe = Geom::Transformation.axes insp_pipe, vec_xn, vec_yn, vec_zn
				@countpb +=1 if (dis_2-r_1-r_2>=-0.00001 and lengthpip>0)
				@cout3tw +=1 if ((angletw.abs>0.0017) and (dis_2-r_1-r_2>=-0.00001))
				Dezmo_pompi2016::pompi_pipe(insp_pipe,nil,lengthpip,trans_for_pipe,angletw) if (dis_2-r_1-r_2>=-0.00001 and lengthpip>0)
				
				Sketchup.active_model.selection.add((Sketchup.active_model.active_entities.add_line(p[i-1],p[i]))) if dis_2-r_1-r_2<=-0.00001
			
			else
				#put back "wrong" line and select
				Sketchup.active_model.selection.add((Sketchup.active_model.active_entities.add_line(p[i-1],p[i])))
			end
		status_text1 = "Finding bends in loops: "+@countb.to_s
		Sketchup::set_status_text status_text1,SB_PROMPT
		}
		#Sketchup.active_model.active_view.refresh
	}
	
	end #self.pompi_auto_loops

	def self.pompi_auto_waves(waves) #(This one a little different method, but same concept as Loops)
	waves.each{|p|	
			if p.length==2
				self.pompi_auto_lines([p])
				next
			end
			#Sketchup.active_model.active_view.refresh
			fit=[true]
			for i in (1..p.length-2)
				if p[i+1]
					fit[i]=fit[i-1]
					v1=p[i].vector_to p[i+1]  
					v_1=p[i-1].vector_to p[i]
					a=v_1.angle_between v1
					a=Math::PI-a if a<=Math::PI
					r=@rbe/Math.tan(a/2)
					dis1 = v1.length
					dis_1 = v_1.length
					fit[i]=false if (i==1 and (dis_1-r<-0.00001 or dis1-r<-0.00001))
				end
				if p[i+2]
					v2=p[i+1].vector_to p[i+2] 
					a1=v1.angle_between v2
					a1=Math::PI-a1 if a1<=Math::PI
					r1=@rbe/Math.tan(a1/2)
					dis2 = v2.length
					fit[i]=false if (i==1 and (dis_1-r<-0.00001 or dis1-r-r1<-0.00001))
					fit[i]=false if (i>1 and i<p.length-1 and (dis1-r-r1<-0.00001 or !fit[i-1]))
					fit[i]=false if (i>1 and i==p.length-1 and (dis1-r<-0.00001 or !fit[i-1]))
				end	
				if fit[i]
					#put bend
					insp_bend= p[i].offset v_1.reverse, r
					vec_zn=v_1.normalize
					plane1= p[i],vec_zn
					vec_y=self.flattenVector(plane1, v1)
					vec_yn=vec_y.normalize
					vec_xn=(vec_yn * vec_zn).normalize
					curent_angle = Math::PI-a if a<=Math::PI #bend angle
					curent_angle = a  if a>Math::PI  #bend angle 
					trans_for_bend = Geom::Transformation.axes insp_bend, vec_xn, vec_yn, vec_zn
					@countb +=1
					self.pompi_bend(insp_bend,nil,curent_angle,trans_for_bend)			

					#put pipe
					insp_pipe=p[i-1] if i==1 #first pipe
					if i>1 and i<p.length-1
						v_2=p[i-2].vector_to p[i-1] 
						a_1=v_2.angle_between v_1
						a_1=Math::PI-a_1 if a_1<=Math::PI
						r_1=@rbe/Math.tan(a_1/2)
						insp_pipe=p[i-1].offset v_1, r_1
						
						angletw_base=self.angle_between_in_Plane(plane1, v_2, v1)
						angletw_base=angletw_base-Math::PI/@spi if @spi%2>0
						angletw=angletw_base%(2*Math::PI/@spi)
						angletw=-(2*Math::PI/@spi)+angletw if angletw>(Math::PI/@spi)					
					end
					angletw=0 if i==1 #first pipe
					lengthpip=insp_pipe.distance insp_bend 
					trans_for_pipe = Geom::Transformation.axes insp_pipe, vec_xn, vec_yn, vec_zn
					@countpb +=1  if lengthpip>0
					@cout3tw +=1 if (angletw.abs>0.0017)
					Dezmo_pompi2016::pompi_pipe(insp_pipe,nil,lengthpip,trans_for_pipe,angletw) if lengthpip>0
					
					#The last pipe
					if i==p.length-2
						insp_pipe=p[i].offset v1, r
						lengthpip=insp_pipe.distance p[i+1]
						vec_zn=v1.normalize
						plane1= p[i],vec_zn
						vec_y=self.flattenVector(plane1, v_1.reverse) #or v_1.reverse
						vec_yn=vec_y.normalize
						vec_xn=(vec_yn * vec_zn).normalize
						trans_for_pipe = Geom::Transformation.axes insp_pipe, vec_xn, vec_yn, vec_zn
						@countpb +=1 if lengthpip>0
						Dezmo_pompi2016::pompi_pipe(insp_pipe,nil,lengthpip,trans_for_pipe,0) if lengthpip>0
					end
					
				else
					#put back "wrong" line and select
					Sketchup.active_model.selection.add((Sketchup.active_model.active_entities.add_line(p[i-1],p[i])))
					Sketchup.active_model.selection.add((Sketchup.active_model.active_entities.add_line(p[i],p[i+1]))) if i==p.length-2
					
				end	#if
			end #for
		status_text1 = "Finding bends in 'waves': "+@countb.to_s
		Sketchup::set_status_text status_text1,SB_PROMPT
		}	
	end #def self.pompi_auto_waves(wa)

	
	def self.pompi_auto_lines(lines)
		lines.each{|p|	
			v1=p[0].vector_to p[1]
			dis1 = v1.length
			@cont4+=1  if dis1>0#
			Dezmo_pompi2016::pompi_pipe(p[0],v1,dis1,nil,nil) if dis1>0#
			status_text1 = "Finding stand alone pipes: "+@cont4.to_s
			Sketchup::set_status_text status_text1,SB_PROMPT
			#Sketchup.active_model.active_view.refresh
		}
	end	#self.pompi_auto_lines(li)



	def self.sort_out_vertices_by_edges (edges=false, check=false, trangrs=Geom::Transformation.new)
			# return waves, loops, lines, edges_3p
			
# Copyright 2016, Dezmo
###############################################################################
# Ideas from: weld.rb form Rick Wilson, and TIG-weld from TIG #### Thanks! ####
###############################################################################
# The method is different here... and can be applied to several unconnected lines at once
#
# The given 'isolated' edges (e.g. grupped and/or moved from the rest of the model) will be processed.
#	(otherwise the edges which are not included here and yet connected may disturb us,
#	so without isolation this method may give unexpected result.)
# The 3rd parameter should be your transformation: e.g.: trangrs=your_temporaly_group.transformation
#
# The edges can be part of curve, circle, polygon... whatever.
# If the second parameter check=true, it will check if everybody is edges, and return back false's if one of it is not.
#	Otherwise (check=false) means you are sure you have given only edges (save some time & resources...)
# The bad edges connected to two or more edges (on same vertex) will be ignored/purged (see below)
#
# So, This will RETURNS VERTICES POSITION in three arrays with subarray(s) in it:
#  waves = [ [wave0] , [wave1] , [wave2]...]  (e.g.: wave0=[startvetex, nextvertex,...,endvertex])
#  loops = [ [loop0] , [loop1] , [loop2]...]  (e.g,: loop0=[arbitraryvertex, nextvertex,...,lastvertex])
#  lines = [ [line0] , [line1] , [line2]...]  (e.g.: line0=[edge.start(vertex), edge.end(vertex)] )
# 		(each of the four arrays may be []/empty/ too)
#   
#  The bad edges array, which can't be determined into above, will be temporally deleted. 
#     Because of this the connected faces also affected!
#  (edges_3 = [bad_edges] (edges_3 means  at least 3 edges /or more/ on same vertex are connected)
#  The deleted edges can be recreated by using the fourth RETURNED VERTITES POSITION of BAD EDGES 
#  edges_3p = [ [badedge0] , [badedge1] , [badedge2]...]  (e.g.: badedge0=[vertex1,vertex2])
# 
# The sub arrays will contain vertices sorted according of connection (one after another) of edges
# The vertex which is on line of two adjacent (neighbouring) vertices will NOT be included. (Purged out.)
#	(Two_edges_on_line=one_longer_edges)
# 	(Becouse of this the waves can be also one edge (2 vertices),  AKA line) 
#
# waves: are sequentially connected edges (minimum 2 /or 1:see above/) with 2 "open" vertices at the start and end (like W ;-)); 
# loops: are sequentially connected edges (minimum 3) in a closed loop (like square or polygon)
# lines: are the orphan (stand alone) edges (not connected to anyone)
#
# The loops subarray first vertex is NOT repeated ad the end of subarray.
# Be aware, the arrays are VERTICES POSITION! ( Point3d )
# (Again: Don't forget about your your_temporaly_group.transformation, makes influence to rest of your process!)
# Feel free to correc my mistakes... and send some coffee if you like...


		#Initial check if desired more deep
		if edges and check
			edges_unsorted=[]
			edges.each {|e| edges_unsorted<<e if e.kind_of?(Sketchup::Edge)} 
			return false,false,false,false if (edges_unsorted.length<edges.length or edges_unsorted.length<1)
			
			elsif edges
			edges_unsorted=edges
			else
			UI.messagebox("Please gimme' somethin'!", MB_OK, "PomPi Auto Tool")
			return
		end

# Lines and bad Edges & (waves and loops for further investigation )		
		waves=[];lines=[];loops=[]
		edges_3=[];edges_2=[]
		cont1=0 #for progress "bar"
		edges_unsorted.each {|e|  
			e.vertices.each {|v|
				if v.edges.length > 2
					edges_3.push(e)  # too much: this is the bad EDGES 
				end
				if v.edges.length == 2
					if (e.other_vertex v).edges.length<=2
					edges_2.push(e) # at least one more edge connected, for further investigation
					end
				end
				if v.edges.length == 1
					if (e.other_vertex v).edges.length==1
						lines.push([e.start.position.transform(trangrs),e.end.position.transform(trangrs)])# the orphans
						break
					end
				end
			}
		#See the progress in status text:
		cont1+=1
		status_text1 = "Finding edge's vertices: "+cont1.to_s+" of: "+ (edges_unsorted.length).to_s+"( Potential...)"
		Sketchup::set_status_text status_text1,SB_PROMPT			
		}
		#lines.uniq!	# ???!!! The uniq! method does not work, on sub-array or what...???!!!??? Result of line, nothing else to do, will returned soon...
		edges_3.uniq! 	# Result of bad edges...

		# Store the vertices position of bad edges:    
		edges_3p=[]
		edges_3.each_with_index{|e,i| edges_3p[i]=[]; e.vertices.each{|v| edges_3p[i]<<v.position.transform(trangrs)} } if edges_3
		edges_2=edges_2-edges_3 #on the bad edges other end can be identified as good edges, so remove it...
		edges_2.uniq!
 		Sketchup.active_model.active_entities.erase_entities(edges_3) # delete/isolate out the bad_edges, will be redrawn later by caller

#Find the Waves and Loops, stage1
		edges_2_stage1 = edges_2
		ed_21=[] #it is a wave (stage1, not sorted)
		ed_22=[] #it is a loop (stage1, not sorted)
		waves_1=[]
		loops_1=[]
		count_edges=0
		while edges_2.length > count_edges # do until the found edges counter reach the length
			if ed_21!=[] or count_edges==0 #start this if the last iteration found "end" edge or noting found yet
				edges_2_stage1.each{|e| 
					ed_21=[]
					e.vertices.each {|v|
						if v.edges.length ==1 # if the vertex have 1 connected edge, than this is one of the waves "end"
							ed_21= e.all_connected.find_all {|e| e.kind_of?(Sketchup::Edge)}  #check if the connected entities are edges
							waves_1<<ed_21 # if found "end" edge push it with all connected, it is a waves array (stage1, not sorted edges)
							count_edges+=ed_21.length #count the edges we found
							edges_2_stage1-=ed_21 # remove it from an inspected array
							break if ed_21!=[] # brake out to be able to start over with the "new" array
						end
					}
					break if ed_21!=[] # break out here too from iteration of edges if found
				}
			end #if
			edges_2_stage1-=ed_21 if ed_21!=[] # remove edges from stage1 array and go back to process again on the remaining
			if ed_21==[] #start this if no more "end" edge
				edges_2_stage1.each{|e| 
					ed_22=e.all_connected.find_all {|e| e.kind_of?(Sketchup::Edge)}  # take the first edge
					loops_1<<ed_22 # push it with all connected; it should be a loops array (stage1, not sorted edges)
					count_edges+=ed_22.length  #count the edges we found
					edges_2_stage1-=ed_22 #remove edges from stage1 array and go back to process again on the remaining
					break # break out if iteration of edges
				}
			end #if
		end #while

#Let sort the Waves, stage2 (almost there we will have sorted vertices here)
		waves_2=[]
		waves_1.each_with_index{|w,i| # the "big" waves arrays, contains w of arrays (imax+1 length)
			waves_2[i]=[]
			count_verts=0
			wlen1i=waves_1[i].length
			# Iterate several times of edge collection until we found/count all
			while wlen1i > count_verts-1 # we have n of edges and n+1 vertices (in current wave: waves_2[i])
				w.each{|e| # one wave contains e of unsorted edges 
					if waves_2[i].length==0 # if we don't have any vertices collection yet, find the first edge which has the "free" end
						if e.start.edges.length==1 # collect the start of edge and end of edge
							waves_2[i]<<e.start
							count_verts+=1
							waves_2[i]<<e.end
							count_verts+=1
							w.delete(e) # I know, I know deleting somthing from iterated collection is not elegant...
							break # ....So to avoid trouble, quicly jumping out from iteration :-)
						end
						if e.end.edges.length==1 # collect the end of edge and start of edge
							waves_2[i]<<e.end
							count_verts+=1
							waves_2[i]<<e.start
							count_verts+=1
							w.delete(e)
							break
						end
					end
					if waves_2[i].length>0  # if we have a vertices, compare the last one to edge.start...
						if waves_2[i].last.position == e.start.position
							waves_2[i]<<e.end  # and push the other vertex of edge
							count_verts+=1 
							w.delete(e)
							break  
						end
						if waves_2[i].last.position == e.end.position # ... or compare to edge.end
							waves_2[i]<<e.start  # and push the other vertex of edge
							count_verts+=1  
							w.delete(e)
							break  
						end
					end
				}# one wave edges
			end#
		}#all waves
		
		#Purge out vertices which are on line of two adjacent (neighbouring) vertices (point.on_line? line), and get position
		waves_2.each_with_index{|w,i| #
			waves[i]=[] 
			w.each_with_index {|v,j|
				if (j>0 and j<=w.length-2)
					wp= w[j].position
					wp_1= w[j-1].position
					wp1=w[j+1].position
					line=[wp_1, wp_1.vector_to(wp1)] 
					von_line=wp.on_line?(line)
				end
				# The first and last for sure pushed, the others depends: if not on line yes, otherwise not
				if ((j==0) or (j==w.length-1) or ((j>0 and j<=w.length-2) and !von_line))
					waves[i].push(v.position.transform(trangrs)) # this is the sorted vertices position of waves
				end
			}# one wave vertices
		}#all waves

#Let sort the Loops, stage2 (almost there we will have sorted vertices here)
		loops_2=[]
		loops_1.each_with_index{|w,i| # the "big" loops arrays, contains w of arrays (imax+1 length)
			loops_2[i]=[]
			count_verts=0
			llen1i=loops_1[i].length
			# Iterate several times of edge collection until we found/count all
			while llen1i > count_verts # we have n of edges and n vertices (in current loop: loops_1[i])
				w.each{|e| # one loop contains e of unsorted edges 
					if loops_2[i].length==0 # if we don't have any vertices yet, find the first random edge
							loops_2[i].push(e.start)
							count_verts+=1
							loops_2[i].push(e.end)
							count_verts+=1
					elsif loops_2[i].length>0 and loops_2[i].last.position == e.start.position # if we have a vertices, compare the last one to edge.start...
						loops_2[i].push(e.end) # and push the other vertex of edge
						count_verts+=1
						w.delete(e)
						break
					elsif loops_2[i].length>0 and loops_2[i].last.position == e.end.position# ... or compare to edge.end
						loops_2[i].push(e.start)# and push the other vertex of edge
						count_verts+=1
						w.delete(e)
						break
					end
				}# one loop edges
			end#
		}#all loops

		#Purge out vertices which are on line of two adjacent (neighbour) vertices (point.on_line? line) , and get position
		loops_2.each_with_index{|w,i| #
			loops[i]=[] 
			w.each_with_index {|v,j|
				line1 = [w[j-1].position, w[j-1].position.vector_to(w[j+1].position)] if (j<w.length-1) 
				line1 = [w[j-1].position, w[j-1].position.vector_to(w[0].position)] if (j==w.length-1)
				# The vertices push depends: if not on line yes, otherwise not
				if (!(v.position.on_line? line1))
					loops[i].push(v.position.transform(trangrs)) # this is the sorted vertices position of loops
				end
			}# one loop vertices
		}#all loops

	return waves, loops, lines, edges_3p

	end #short_edges_vertices


######################## (This bits from:Eneroth3 ##############################
#Eneroth 3D Rotate Tool
#http://sketchucation.com/pluginstore?listtype=1&author=0&category=0&search=3D+rot&submit=%3F
#Author:	Julia Christina Eneroth, Eneroth3, eneroth3@gmail.com
	def self.angle_between_in_Plane(plane, v1, v2)
		#Get angle between vectors in a given plane
		#Can return negative angles unlike built in angleBetween method
		
		#Flatten to plane
		v1 = self.flattenVector(plane,v1)
		v2 = self.flattenVector(plane,v2)
		
		#Get angle between
		a = v1.angle_between v2
		
		#Determine if angle is positive or negative (rotate v2 90 degrees cc and cw seen from above and see which is closest to v2)
		negAnglePointForward = Geom::Point3d.new.offset v2
		negAnglePointPos = negAnglePointForward.transform(Geom::Transformation.rotation(Geom::Point3d.new, plane[1], Math::PI/2))
		negAnglePointNeg = negAnglePointForward.transform(Geom::Transformation.rotation(Geom::Point3d.new, plane[1], -Math::PI/2))
		negAnglePointCheck = Geom::Point3d.new.offset v1
		a*= -1 if (negAnglePointCheck.distance negAnglePointNeg) < (negAnglePointCheck.distance negAnglePointPos)
		
		return a
	end#def
	
	def self.flattenVector(plane, vector)
		#Flatten vector to plane
		#plane's point does not affect output, only its normal does
		
		pointStart = plane[0]
		normal = plane[1]
		
		#Point at end of vector
		pointVectorEnd = pointStart.offset vector
		#point projected to plane
		pointIntesection = pointVectorEnd.project_to_plane plane
		#vector from startpoint to intersection
		outputVector = pointIntesection.- pointStart
		return outputVector
	end#def	
######################## This bits from:Eneroth3) ##############################

end #module Dezmo_pompi2016